<?php
 /*
   Rule CPT rows are stored.  At rule store/update
   time, a master rule option array is (re)created, to allow speedier access to rule information at
   product/cart processing time.
 */
   
class VTPRD_Rules_UI{ 
	
	public function __construct(){       
    global $post, $vtprd_info;
    
    //ACTION TO ALLOW THEME TO OFFER ALL PRODUCTS AT A DISCOUNT.....
    
        
    add_action( 'add_meta_boxes_vtprd-rule', array(&$this, 'vtprd_remove_meta_boxes') );   
    add_action( 'add_meta_boxes_vtprd-rule', array(&$this, 'vtprd_add_metaboxes') );
    add_action( "admin_enqueue_scripts",     array(&$this, 'vtprd_enqueue_admin_scripts') );

    add_action( 'add_meta_boxes_vtprd-rule', array($this, 'vtprd_remove_all_in_one_seo_aiosp') ); 
    
    //AJAX actions
    //   uses the action name from the js....
    add_action( 'wp_ajax_vtprd_ajax_load_variations_in',         array(&$this, 'vtprd_ajax_load_variations_in') ); 
    add_action( 'wp_ajax_vtprd_ajax_load_variations_out',        array(&$this, 'vtprd_ajax_load_variations_out') );
    add_action( 'wp_ajax_noprov_vtprd_ajax_load_variations_in',  array(&$this, 'vtprd_ajax_load_variations_in') );      
    add_action( 'wp_ajax_noprov_vtprd_ajax_load_variations_out', array(&$this, 'vtprd_ajax_load_variations_out') );     
      
    //add a metabox to the **parent product custom post type page**
    add_action( 'add_meta_boxes_' .$vtprd_info['parent_plugin_cpt'] , array(&$this, 'vtprd_parent_product_meta_box_cntl') );
	}
                               
    
  public function vtprd_enqueue_admin_scripts() {
    global $post_type, $vtprd_info;
    if( $post_type == 'vtprd-rule' ){ 
        wp_register_style( 'vtprd-admin-style', VTPRD_URL.'/admin/css/vtprd-admin-style.css' );  
        wp_enqueue_style('vtprd-admin-style');
        
        wp_register_script( 'vtprd-admin-script', VTPRD_URL.'/admin/js/vtprd-admin-script.js' );  
        //create ajax resource
        wp_localize_script( 'vtprd-admin-script', 'variationsInAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )  ));        
        //create ajax resource
        wp_localize_script( 'vtprd-admin-script', 'variationsOutAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )  ));                
        wp_enqueue_script('vtprd-admin-script');

        
        //Datepicker resources, some part of WP
        wp_enqueue_script( 'jquery-ui-core' );
        wp_enqueue_script( 'jquery-ui-datepicker' );
        wp_register_style( 'vtprd-jquery-datepicker-style', VTPRD_URL.'/admin/css/smoothness/jquery-ui-1.10.2.custom.css' );  
        wp_enqueue_style ('vtprd-jquery-datepicker-style');
      }
    //These are for the include/exclude meta box on the parent plugin PRODUCT page
    if( $post_type == $vtprd_info['parent_plugin_cpt']){
      wp_register_style('vtprd-admin-product-metabox-style', VTPRD_URL.'/admin/css/vtprd-admin-product-metabox-style.css' );  
      wp_enqueue_style( 'vtprd-admin-product-metabox-style');
      if (defined('VTPRD_PRO_DIRNAME'))  {
        $register_metabox_script = VTPRD_PRO_URL.'/admin/js/vtprd-admin-product-metabox-script.js';
      } else {
        $register_metabox_script = VTPRD_URL.'/admin/js/vtprd-admin-product-metabox-script.js';
      }     
      wp_register_script('vtprd-admin-product-metabox-script', $register_metabox_script );
      wp_enqueue_script('vtprd-admin-product-metabox-script');    
    }
  }    
  
  public function vtprd_remove_meta_boxes() {
     if(!current_user_can('administrator')) {  
      	remove_meta_box( 'revisionsdiv', 'post', 'normal' ); // Revisions meta box
        remove_meta_box( 'commentsdiv', 'vtprd-rule', 'normal' ); // Comments meta box
      	remove_meta_box( 'authordiv', 'vtprd-rule', 'normal' ); // Author meta box
      	remove_meta_box( 'slugdiv', 'vtprd-rule', 'normal' );	// Slug meta box        	
      	remove_meta_box( 'postexcerpt', 'vtprd-rule', 'normal' ); // Excerpt meta box
      	remove_meta_box( 'formatdiv', 'vtprd-rule', 'normal' ); // Post format meta box
      	remove_meta_box( 'trackbacksdiv', 'vtprd-rule', 'normal' ); // Trackbacks meta box
      	remove_meta_box( 'postcustom', 'vtprd-rule', 'normal' ); // Custom fields meta box
      	remove_meta_box( 'commentstatusdiv', 'vtprd-rule', 'normal' ); // Comment status meta box
      	remove_meta_box( 'postimagediv', 'vtprd-rule', 'side' ); // Featured image meta box
      	remove_meta_box( 'pageparentdiv', 'vtprd-rule', 'side' ); // Page attributes meta box
        remove_meta_box( 'categorydiv', 'vtprd-rule', 'side' ); // Category meta box
        remove_meta_box( 'tagsdiv-post_tag', 'vtprd-rule', 'side' ); // Post tags meta box
        remove_meta_box( 'tagsdiv-vtprd_rule_category', 'vtprd-rule', 'side' ); // vtprd_rule_category tags  
        remove_meta_box( 'relateddiv', 'vtprd-rule', 'side');                  
      } 
 
  }
 
        
  public  function vtprd_add_metaboxes() {
      global $post, $vtprd_info, $vtprd_rule, $vtprd_rules_set;        

      $found_rule = false;                            
      if ($post->ID > ' ' ) {
        $post_id =  $post->ID;
        $vtprd_rules_set   = get_option( 'vtprd_rules_set' ) ;

        $sizeof_rules_set = sizeof($vtprd_rules_set);
        for($i=0; $i < $sizeof_rules_set; $i++) {  
           if ($vtprd_rules_set[$i]->post_id == $post_id) {
              $vtprd_rule = $vtprd_rules_set[$i];  //load vtprd-rule               
              $found_rule = true;
              $found_rule_index = $i; 
              $i = $sizeof_rules_set;              
           }
        }
      } 

      if (!$found_rule) {
        $this->vtprd_build_new_rule();        
      } 
           
      add_meta_box('vtprd-deal-selection',  __('Pricing Deals', 'vtprd') , array(&$this, 'vtprd_deal'), 'vtprd-rule', 'normal', 'high');

      //side boxes
      add_meta_box('vtprd-rule-id', __('Rule In Words', 'vtprd'), array(&$this, 'vtprd_rule_id'), 'vtprd-rule', 'side', 'low'); //low = below Publish box
      add_meta_box('vtprd-rule-resources', __('Resources', 'vtprd'), array(&$this, 'vtprd_rule_resources'), 'vtprd-rule', 'side', 'low'); //low = below Publish box 

      //create help tab...                                                                                                                                                                                                          
      $content;
      $content .= '<br><a id="pricing-deal-title-more2" class="more-anchor" href="javascript:void(0);"><img class="pricing-deal-title-helpPng" alt="help"  width="14" height="14" src="' . VTPRD_URL .  '/admin/images/help.png" />' .    __(' Help! ', 'vtprd')  .'&nbsp;'.   __('Tell me about Pricing Deals ', 'vtprd') . '<img class="plus-button" alt="help" height="10px" width="10px" src="' . VTPRD_URL . '/admin/images/plus-toggle2.png" /></a>';            
      $content .= '    <a id="pricing-deal-title-less2" class="more-anchor less-anchor" href="javascript:void(0);"><img class="pricing-deal-title-helpPng" alt="help" width="14" height="14" src="' . VTPRD_URL . '/admin/images/help.png" />' . __('   Less Pricing Deals Help ... ', 'vtprd') . '<img class="minus-button" alt="help" height="12px" width="12px" src="' . VTPRD_URL . '/admin/images/minus-toggle2.png" /></a>';   
      
      $screen = get_current_screen();
      $screen->add_help_tab( array( 
         'id' => 'vtprd-help',            //unique id for the tab
         'title' => 'Pricing Deals Help',      //unique visible title for the tab
         'content' => $content  //actual help text
        ) );  
  }                   
   
                                                    
  public function vtprd_error_messages() {     
      global $post, $vtprd_rule;

      $error_msg_count = sizeof($vtprd_rule->rule_error_message);
       ?>        
          <script type="text/javascript">
          jQuery(document).ready(function($) {           
          $('<div class="vtprd-error" id="vtprd-error-announcement"><?php _e("Please Repair Errors below", "vtprd"); ?></div>').insertBefore('#vtprd-deal-selection');  
      <?php 
      //loop through all of the error messages 
      //          $vtmax_info['line_cnt'] is used when table formattted msgs come through.  Otherwise produces an inactive css id. 
     for($i=0; $i < $error_msg_count; $i++) { 
       ?>
             $('<div class="vtprd-error"><?php echo $vtprd_rule->rule_error_message[$i]['error_msg'];?></div>').insertBefore('<?php echo $vtprd_rule->rule_error_message[$i]['insert_error_before_selector']; ?>');
      <?php 
  
      }  //end 'for' loop      
      ?>   
            });   
          </script>
     <?php 
     
     //Change the label color to red for fields in error
     if ( sizeof($vtprd_rule->rule_error_red_fields) > 0 )  {
      
       echo '<style>' ;   // echo '<style type="text/css">' ;
       for($i=0; $i < sizeof($vtprd_rule->rule_error_red_fields); $i++) { 
          if ($i > 0) { // if 2nd to n field name, put comma before the name...
            echo ', ';
          }
          echo $vtprd_rule->rule_error_red_fields[$i];
       }
       echo '{color:red; display:block; float:left; margin: 0 5px;}' ;         // display:block added for hidden date err msg fields
       echo '</style>' ;
     }

      
      if( $post->post_status == 'publish') { //if post status not = pending, make it so  
          $post_id = $post->ID;
          global $wpdb;
          $wpdb->update( $wpdb->posts, array( 'post_status' => 'pending' ), array( 'ID' => $post_id ) );
      } 

  }   

/* **************************************************************
    Deal Selection Metabox
                                                                                     
    Includes: 
    - Rule type info
    - Rule deal info
    - applies-to max info
    - rule catalog/cart display msgs
    - cumulative logic rule switches
************************************************************** */                                                   
  public function vtprd_deal() {     
      global $vtprd_rule_template_framework, $vtprd_deal_structure_framework, $vtprd_deal_screen_framework, $vtprd_rule_display_framework, $vtprd_rule, $vtprd_setup_options;
      $selected = 'selected="selected"';
      $checked = 'checked="checked"';
      $disabled = 'disabled="disabled"' ; 
      $vtprdNonce = wp_create_nonce("vtprd-rule-nonce"); //nonce verified in vt-pricing-deals.php
                
      if ( sizeof($vtprd_rule->rule_error_message ) > 0 ) {    //these error messages are from the last upd action attempt, coming from vtprd-rules-update.php
           $this->vtprd_error_messages();
      } 
    
      $currency_symbol = vtprd_get_currency_symbol();
    
      //**********************************************************************
      //IE CSS OVERRIDES, done here to ensure they're last in line...
      //**********************************************************************
      echo '<!--[if IE]>';
	    echo '<link rel="stylesheet" type="text/css"  media="all" href="' .VTPRD_URL.'/admin/css/vtprd-admin-style-ie.css" />';
      echo '<![endif]-->';
      // end override
       
      //This Div only shows if there is a JS error in the customer implementation of the plugin, as the JS hides this div, if the JS is active
      //vtprd_show_help_if_js_is_broken();  
      
      ?>
        
        <script type="text/javascript">
        jQuery(document).ready(function($) {
        
        //Spinner gif wasn't working... 
         $('.spinner').append('<img src="<?php echo VTPRD_URL;?>/admin/images/indicator.gif" />');
       
          });   
        </script>
     
       <?php /*
       <div class="hide-by-jquery">
        <span class="">< ?php _e('If you can see this, there is a JavaScript Error on the Page. Hover over this &rarr;', 'vtprd'); ? > </span>
            < ?php vtprd_show_help_tooltip($context = 'onlyShowsIfJSerror', $location = 'title'); ? >
       </div>
       */
       ?>

    <?php //BANNER AND BUTTON AREA ?>
                         

    
    <img id="pricing-deals-img-preload" alt="" src="<?php echo VTPRD_URL;?>/admin/images/upgrade-bkgrnd-banner.jpg" />
 		<div id="upgrade-title-area">
      <a  href=" <?php echo VTPRD_PURCHASE_PRO_VERSION_BY_PARENT ; ?> "  title="Purchase Pro">
      <img id="pricing-deals-img" alt="help" height="40px" width="40px" src="<?php echo VTPRD_URL;?>/admin/images/sale-circle.png" />
      </a>      
      <h2>
        <?php _e('Pricing Deals', 'vtprd'); ?>
        <?php if(defined('VTPRD_PRO_DIRNAME')) {  
                _e(' Pro', 'vtprd');
              }
        ?>    
        
        </h2>  
      
      <?php if(!defined('VTPRD_PRO_DIRNAME')) {  ?> 
          <span class="group-power-msg">
            <strong><em><?php _e('Create rules for Any Group you can think of, and More!', 'vtprd'); ?></em></strong>
            <?php /* 
              - Product Category
              - Pricing Deal Custom Category
              - Logged-in Status
              - Product
              - Variations!
                */ ?> 
          </span> 
          <span class="buy-button-area">
            <a href="<?php echo VTPRD_PURCHASE_PRO_VERSION_BY_PARENT; ?>" class="help tooltip tooltipWide buy-button">
                <span class="buy-button-label"><?php _e('Get Pricing Deals Pro', 'vtprd'); ?></span>
                <b> <?php vtprd_show_help_tooltip_text('upgradeToPro'); ?> </b>
            </a>
          </span> 
      <?php }  ?>
          
    </div>  

            
      <?php //RULE EXECUTION TYPE ?> 
      <div class="display-virtual_box  top-box">                           
        
        <?php //************************ ?>
        <?php //HIDDEN FIELDS BEGIN ?>
        <?php //************************ ?>
        <?php //RULE EXECUTION blue-dropdownS - only one actually displays at a time, depending on ?>
        <input type="hidden" id="vtprd_nonce" name="vtprd_nonce" value="<?php echo $vtprdNonce; ?>" >
        <?php //Hidden switch to communicate with the JS that the data is 1st time screenful ?>
        <input type="hidden" id="firstTimeBackFromServer" name="firstTimeBackFromServer" value="yes" >        
        <input type="hidden" id="upperSelectsFirstTime" name="upperSelectsFirstTime" value="yes" >
        <input type="hidden" id="upperSelectsDoneSw" name="upperSelectsDoneSw" value="" >
        <?php 
           /*
            Assign a numeric value to the switch
              showing HOW MANY selects have data
                on 1st return from server...
           */           
           $data_sw = '0';
           
           //test the Various group filter selects and set a value...
           switch( true) {
              case ( ($vtprd_rule->get_group_filter_select > ' ') &&
                     ($vtprd_rule->get_group_filter_select != 'choose') ):
                  $data_sw = '5';
                break;
              case ( ($vtprd_rule->buy_group_filter_select > ' ') &&
                     ($vtprd_rule->buy_group_filter_select != 'choose') ):
                  $data_sw = '4';
                break;  
              case ( ($vtprd_rule->minimum_purchase_select > ' ') &&
                     ($vtprd_rule->minimum_purchase_select != 'choose') ):              
                  $data_sw = '3';
                break;   
              case ( ($vtprd_rule->pricing_type_select > ' ') &&
                     ($vtprd_rule->pricing_type_select != 'choose') ):
                  $data_sw = '2';
                break;   
              case ( ($vtprd_rule->cart_or_catalog_select > ' ') &&
                     ($vtprd_rule->cart_or_catalog_select != 'choose') ):              
                  $data_sw = '1';
                break;                    
             } 
             
             /*  upperSelectsHaveDataFirstTime has values from 0 => 5
             value = 0  no previous data saved 
             value = 1  last run got to:  cart_or_catalog_select
             value = 2  last run got to:  pricing_type_select
             value = 3  last run got to:  minimum_purchase_select
             value = 4  last run got to:  buy_group_filter_select
             value = 5  last run got to:  get_group_filter_select
             */
        ?>
        <input type="hidden" id="upperSelectsHaveDataFirstTime" name="upperSelectsHaveDataFirstTime" value="<?php echo $data_sw; ?>" >
        
        <input type="hidden" id="templateChanged" name="templateChanged" value="no" > 
        
        <?php //Statuses used for switching of the upper dropdowns ?>
        <input type="hidden" id="select_status_sw"  name="select_status_sw"  value="no" >
        
        <?php //pass these two messages up to JS, translated here if necessary ?>
        <input type="hidden" id="fullMsg" name="fullMsg" value="<?php _e('Full theme message required', 'vtprd');?>" >    
        <input type="hidden" id="shortMsg" name="shortMsg" value="<?php _e('Short checkout message required', 'vtprd');?>" > 
  
        <input id="pluginVersion" type="hidden" value="<?php if(defined('VTPRD_PRO_DIRNAME')) { echo "proVersion"; } else { echo "freeVersion"; } ?>" name="pluginVersion">  
        <input id="rule_template_framework" type="hidden" value="<?php echo $vtprd_rule->rule_template;  ?>" name="rule_template_framework">
              
           
        <?php //************************ ?>
        <?php //HIDDEN FIELDS END ?>
        <?php //************************ ?>

        <div class="template-area clear-left">  
          
          <div class="clear-left" id="first-blue-line">                          
            
            <span class="blue-dropdown">                              
               <label for="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['label']['for'];?>"><?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['label']['title'];?></label>
               <select id="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['cart_or_catalog_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['cart_or_catalog_select']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['cart_or_catalog_select']['option'][$i]['value'] == $vtprd_rule->cart_or_catalog_select )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['cart_or_catalog_select']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>                        
            </span>                                                                      
                                  
            <span class="blue-dropdown">                              
               <label for="<?php echo $vtprd_rule_display_framework['pricing_type_select']['label']['for'];?>"><?php echo $vtprd_rule_display_framework['pricing_type_select']['label']['title'];?></label>
               <select id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['pricing_type_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['pricing_type_select']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['pricing_type_select']['option'][$i]['value'] == $vtprd_rule->pricing_type_select )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>                         
            </span>  

            <span class="blue-dropdown blue-dropdown-minimum">                              
               <label for="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['label']['for'];?>"><?php echo $vtprd_rule_display_framework['minimum_purchase_select']['label']['title'];?></label>
               <select id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['minimum_purchase_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['minimum_purchase_select']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['value'] == $vtprd_rule->minimum_purchase_select )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>                         
            </span>  
          </div> <?php //end first-blue-line ?>  
                
          <div class="clear-left" id="second-blue-line">          
            
            <span class="blue-dropdown">                              
               <label id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['label']['id'];?>" for="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['label']['for'];?>"><?php echo $vtprd_rule_display_framework['buy_group_filter_select']['label']['title'];?></label>
               <select id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['buy_group_filter_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['buy_group_filter_select']['option']); $i++) { 
                      
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title3'];                        
                      }
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['value'] == $vtprd_rule->buy_group_filter_select )  { echo $selected; } ?> >  <?php echo $title ?> </option>
                 <?php } ?> 
               </select>                                      
            </span> 
                                                 
            <span class="blue-dropdown">                              
               <label id="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['label']['id'];?>" for="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['label']['for'];?>"><?php echo $vtprd_rule_display_framework['get_group_filter_select']['label']['title'];?></label>
               <select id="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['get_group_filter_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['get_group_filter_select']['option']); $i++) { 
                      
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['title3'];                        
                      }                 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['get_group_filter_select']['option'][$i]['value'] == $vtprd_rule->get_group_filter_select )  { echo $selected; } ?> >  <?php echo $title; ?> </option>
                 <?php } ?> 
               </select>                          
            </span>   
                   
          </div> <?php //end second-blue-line ?> 
                   
          <div class="clear-left" id="third-blue-line"> 
            <span class="blue-dropdown scheduling-group">                                        
                <label class="scheduling-label"><?php _e('Schedule', 'vtprd');?></label>   
                <span class="date-line clear-left" id='date-line-0'>                               
               <?php //   <label class="scheduling-label">Scheduling</label> ?>                                              
                    <span class="date-line-area clear-left">  
                      <?php  $this->vtprd_rule_scheduling(); ?> 
                    </span>             
                </span> 
                  
                  <span class="on-off-switch">                              
                  <?php //     <label for="rule-state-select">On/Off Switch</label>  ?> 
                     <select id="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['rule_on_off_sw_select']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['select']['tabindex']; ?>" >          
                       <?php
                       for($i=0; $i < sizeof($vtprd_rule_display_framework['rule_on_off_sw_select']['option']); $i++) { 
                       ?>                             
                          <option id="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['rule_on_off_sw_select']['option'][$i]['value'] == $vtprd_rule->rule_on_off_sw_select )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['rule_on_off_sw_select']['option'][$i]['title']; ?> </option>
                       <?php } ?> 
                     </select>                        
                  </span>                                   
              </span>

                      <a id="deal-type-title-more" class="more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
                      <a id="deal-type-title-less" class="more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...&nbsp;&nbsp;', 'vtprd'); ?><img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
                                                          
  
   
                    <?php vtprd_show_help_selection_panel_A('0'); ?>
                  </div> <?php //end third-blue-line ?>
                                                         
             </div> <?php //end template-area ?>                       




     </div> <?php //end top-box ?> 

          <a id="pricing-deal-title-more" class="more-anchor  clear-both" href="javascript:void(0);"><?php _e(' Help! Tell Me About Pricing Deals ', 'vtprd');?><img class="plus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
          <a id="pricing-deal-title-less" class="more-anchor less-anchor clear-both" href="javascript:void(0);"><?php _e('   Less Pricing Deals Help ...', 'vtprd'); ?><img class="minus-button" alt="help" height="14px" width="14px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>              
          <?php //Help Panel for PRICING DEAL SELECTION whole box, controlled in metaBox_title area above    
             vtprd_show_help_selection_panel_0();  ?>                 
     
  <div class="display-virtual_box hideMe" id="lower-screen-wrapper" >


                      <a id="pricing-deal-examples-more" class="more-anchor hideMe" href="javascript:void(0);"><img class="pricing-deal-examples-helpPng" alt="help"  width="14" height="14" src="<?php echo VTPRD_URL;?>/admin/images/help.png" /><?php _e(' Pricing Deal Examples ', 'vtprd'); ?><img class="plus-button" alt="help" height="14px" width="14px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
                      <a id="pricing-deal-examples-less" class="more-anchor less-anchor hideMe" href="javascript:void(0);"><img class="pricing-deal-examples-helpPng" alt="help" width="14" height="14" src="<?php echo VTPRD_URL;?>/admin/images/help.png" /><?php _e('   Less Examples ...', 'vtprd'); ?><img class="minus-button" alt="help" height="14px" width="14px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>              
 
                    <div class="selection-panel-wrapper hideMe">  <?php //wrapper needed to uniquely address the in-panel dropdown triggers ?> 
                    <?php vtprd_show_help_selection_panel_5(); ?>
                     </div>
            
          
  
      <?php //****************  
            //DEAL INFO GROUP  
            //**************** ?> 
 
     <div class="display-virtual_box  clear-left" id="rule_deal_info_group">  
                       
      <?php  for($k=0; $k < sizeof($vtprd_rule->rule_deal_info[$k]); $k++) {  ?>         
      <div class="display-virtual_box rule_deal_info" id="rule_deal_info_line<?php echo '_' .$k; ?>">   
        <div class="display-virtual_box" id="buy_info<?php echo '_' .$k; ?>">  
         
           <input id="hiddenDealInfoLine<?php echo '_' .$k; ?>" type="hidden" value="lineActive" name="dealInfoLine<?php echo '_' .$k; ?>" >

           <?php 
              //*****************************************************
              //set the switch used on the screen for JS data check 
              //*****************************************************  ?>
           <?php //end switch ************************************** ?> 
         <div class="screen-box buy_group_title_box">
            <span class="buy_group_title-area">
              <img class="buy_amt_title_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />              
              
              <?php //EITHER / OR TITLE BASED ON DISCOUNT PRICING TYPE ?>
              <span class="section-headings first-level-title showBuyAsDiscount" id="buy_group_title_asDiscount">
                <?php _e('Buy Group ', 'vtprd');?><span class="label-no-cap">&nbsp;&nbsp;<?php _e('(Discount Group)', 'vtprd');?></span>
              </span>
              <span class="section-headings first-level-title showBuyAsBuy" id="buy_group_title_asBuy">
                <?php _e('Buy Group', 'vtprd');?>
              </span>
             
            </span>
         </div>             
         <div class="screen-box buy_amt_box  buy_amt_box_class<?php echo '_' .$k; ?>" id="buy_amt_box<?php echo '_' .$k; ?>" >
            <span class="title" id="buy_amt_title<?php echo '_' .$k; ?> ">
              <a id="buy_amt_title_anchor<?php echo '_' .$k; ?>" class="title-anchors second-level-title" href="javascript:void(0);"><span class="showBuyAsBuy"><?php _e('Buy Group Amount:', 'vtprd');?></span><span class="showBuyAsDiscount"><?php _e('Discount Group Amount:', 'vtprd');?></span></a>
            </span>                                                
            <?php vtprd_show_help_tooltip($context = 'buy-amt-title', $location = 'title'); ?>              
            <span class="shortIntro buyShortIntro" ><?php echo __(' ...  "BUY 5 / ', 'vtprd') .$currency_symbol. __('500"...', 'vtprd');?></span>             
            <a id="buy-amt-title-more<?php echo '-' .$k; ?>" class="buy-amt-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></span></a>
            <a id="buy-amt-title-less<?php echo '-' .$k; ?>" class="buy-amt-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...&nbsp;&nbsp;', 'vtprd'); ?><img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
                            
 
            <span class="dropdown buy_amt clear-left" id="buy_amt_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_type']['option']); $i++) { 
                          $this->vtprd_change_title_currency_symbol('buy_amt_type', $i, $currency_symbol);
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['id'] . '_'  .$k; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['buy_amt_type'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['title']; ?> </option>
                 <?php } ?>                   
                   </select>              
                 <span class="buy_amt_line_remainder  buy_amt_line_remainder_class<?php echo '_' .$k; ?>" id="buy_amt_line_remainder<?php echo '_' .$k; ?>">   
                     <span class="amt-field buy_amt_count" id="buy_amt_count_area<?php echo '_' .$k; ?>">
                       <span class="amt-field-label" id="buy_amt_count_label<?php echo '_' .$k; ?>"> 
                          <span class="buy_amt_count_literal  buy_amt_count_literal<?php echo '_' .$k;?> " id="buy_amt_count_literal_quantity<?php echo '_' .$k; ?>"><?php _e('Qty: ', 'vtprd');?> </span>                          
                          <span class="buy_amt_count_literal  buy_amt_count_literal<?php echo '_' .$k;?> " id="buy_amt_count_literal_currency<?php echo '_' .$k; ?>"><?php echo $currency_symbol . ':'; ?> </span>
                          <span class="buy_amt_count_literal  buy_amt_count_literal<?php echo '_' .$k;?> " id="buy_amt_count_literal_nthQuantity<?php echo '_' .$k; ?>"><?php _e('Nth (number): ', 'vtprd');?> </span> 
                       </span>
                       <input id="<?php echo $vtprd_deal_screen_framework['buy_amt_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['buy_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['buy_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_amt_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['buy_amt_count']; ?>">
                     </span>
                     <span class="dropdown-label" id="buy_amt_applies_to_label<?php echo '_' .$k; ?>">
                        <?php vtprd_show_help_tooltip($context = 'buy-amt-applies-to', $location = 'title'); ?>
                        <?php _e('Applies To: ', 'vtprd');?> 
                     </span>                 
                     <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_applies_to']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['tabindex']; ?>" >          
                       <?php
                       for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_applies_to']['option']); $i++) { 
                       ?>                             
                          <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['id'] . '_' .$k; //. '_'  .$k . '_' .$i; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['buy_amt_applies_to'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['title']; ?> </option>
                       <?php } ?> 
                     </select> 
                 </span>               
            </span>
            <?php vtprd_show_help_selection_panel_B($k); ?>
            <?php vtprd_show_help_selection_panel_C($k); ?>
         </div>
                    
         <div class="screen-box buy_amt_mod_box  buy_amt_mod_box_class<?php echo '_' .$k; ?>" id="buy_amt_mod_box<?php echo '_' .$k; ?>" > 
            <span class="title third-level-title" id="buy_amt_mod_title<?php echo '_' .$k; ?>" >
              <a id="buy_amt_mod_title_anchor<?php echo '_' .$k; ?>" class="title-anchors third-level-title" href="javascript:void(0);"><span class="showBuyAsBuy"><?php _e('Buy Group Min/Max:', 'vtprd');?></span><span class="showBuyAsDiscount"><?php _e('Discount Group Min/Max:', 'vtprd');?></span></a> 
            </span>
              <?php vtprd_show_help_tooltip($context = 'buy_amt_mod_title', $location = 'title'); ?> 
            <span class="shortIntro buyShortIntro" ><?php echo __(' ...  "Buy 5 units FOR A MINIMUM OF ', 'vtprd') .$currency_symbol.  __('300, Get"...', 'vtprd');?></span>           
            <span class="dropdown buy_amt_mod clear-left" id="buy_amt_mod_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_mod']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_mod']['option']); $i++) {
                          $this->vtprd_change_title_currency_symbol('buy_amt_mod', $i, $currency_symbol);                  
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['buy_amt_mod'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>
              
               <span class="amt-field  buy_amt_mod_count_area  buy_amt_mod_count_area_class<?php echo '_' .$k; ?>" id="buy_amt_mod_count_area<?php echo '_' .$k; ?>">
                 <span class="amt-field-label" id="buy_amt_mod_count_label<?php echo '_' .$k; ?>"> <?php echo $currency_symbol . ':'; ?> </span> 
                 <input id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['buy_amt_mod_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['buy_amt_mod_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_amt_mod_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['buy_amt_mod_count']; ?>">
               </span>   
            </span>
         </div>

         <div class="screen-box buy_group_box_class" id="buy_group_box" >
            <span class="title" id="buy_group_title">
              <a id="buy_group_title_anchor" class="title-anchors second-level-title" href="javascript:void(0);"><span class="showBuyAsBuy"><?php _e('Buy Group Filter:', 'vtprd');?></span><span class="showBuyAsDiscount"><?php _e('Discount Group Filter:', 'vtprd');?></span> </a>  
            </span>
            <?php vtprd_show_help_tooltip($context = 'buy-group-title', $location = 'title'); ?>  
            <span class="shortIntro buyShortIntro" ><?php echo __(' ...  "BUY 5 Items.. Filtered By Category / Logged-in Status / Customer Category" ...', 'vtprd');?></span>           
            <span class="dropdown buy_group clear-left" id="buy_group_dropdown">              
               <select id="<?php echo $vtprd_rule_display_framework['inPop']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['inPop']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['inPop']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['inPop']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['inPop']['option']); $i++) { 
                      
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['inPop']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title3'];                        
                      }                 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['inPop']['option'][$i]['value'] == $vtprd_rule->inPop )  { echo $selected; } ?> >  <?php echo $title; ?> </option>
                 <?php } ?> 
               </select>             
               <span class="buy_group_line_remainder_class" id="buy_group_line_remainder">   
                  <?php $this->vtprd_buy_group_cntl(); ?> 
               </span>               
            </span>                                                                          
          
            <?php //vtprd_show_help_selection_panel_X(); ?>
         </div>
                    
          <div class="screen-box buy_repeat_box  buy_repeat_box_class<?php echo '_' .$k; ?>" id="buy_repeat_box<?php echo '_' .$k; ?>" >     <?php //Rule repeat shifted to end of action area, although processed first ?> 
            <span class="title third-level-title" id="buy_repeat_title<?php echo '_' .$k; ?> ">
               <a id="buy_repeat_title_anchor<?php echo '_' .$k; ?>" class="title-anchors third-level-title" href="javascript:void(0);"><span class="showBuyAsBuy"><?php echo __('Rule Repeat', 'vtprd') .'&nbsp;&nbsp;&nbsp;'.  __(' (buy group repeat):', 'vtprd');?></span><span class="showBuyAsDiscount"><?php echo __('Rule Repeat', 'vtprd') .'&nbsp;&nbsp;&nbsp;'.  __(' (discount group repeat):', 'vtprd');?></span></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'buy_repeat_condition_title', $location = 'title'); ?> 
            <span class="shortIntro buyShortIntro" ><?php echo __(' ...  "FOR EACH TIME you buy 5 / ', 'vtprd') .$currency_symbol.  __('500', 'vtprd') .'&nbsp;&nbsp;&nbsp;'.  __('(in this cart)"...', 'vtprd'); ?></span>           
            <span class="dropdown buy_repeat clear-left" id="buy_repeat_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['buy_repeat_condition']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_repeat_condition']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['buy_repeat_condition'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>              
               <span class="amt-field  buy_repeat_count_area  buy_repeat_count_area_class<?php echo '_' .$k; ?>" id="buy_repeat_count_area<?php echo '_' .$k; ?>">
                    <?php vtprd_show_help_tooltip($context = 'buy_repeat_condition_title'); ?>                 
                 <span class="amt-field-label" id="buy_repeat_count_label<?php echo '_' .$k; ?>"> 
                    <?php _e('Count: ', 'vtprd');?> 
                  </span>
                 <input id="<?php echo $vtprd_deal_screen_framework['buy_repeat_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['buy_repeat_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['buy_repeat_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['buy_repeat_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['buy_repeat_count']; ?>">                
               </span>
           </span>
         </div>         
                  
        </div> <?php //end  buy_info display-virtual_box ?>
           
        <?php //GET INFO  ?>        
        <span class="box-border-line">&nbsp;</span>
        <div class="display-virtual_box action_info" id="action_info<?php echo '_' .$k; ?>"> 
        
         <div class="screen-box get_group_title_box">
            <span class="get_group_title-area">
              <img class="get_amt_title_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />              
              <span class="section-headings first-level-title showGetAsDiscount" id="get_group_title_active">
                <?php _e('Get Group ', 'vtprd');?><span class="label-no-cap">&nbsp;&nbsp;<?php _e('(Discount Group)', 'vtprd');?></span>
              </span>
              <span class="section-headings first-level-title showGetAsGet" id="get_group_title_inactive">
                <?php _e('Get Group ', 'vtprd');?><span class="label-no-cap">&nbsp;&nbsp;<?php _e('(Inactive)', 'vtprd');?></span>
              </span>
              
            </span>
         </div> 
                  
         <div class="screen-box action_amt_box  action_amt_box_class<?php echo '_' .$k; ?>" id="action_amt_box<?php echo '_' .$k; ?>" > 
            <span class="title" id="action_amt_type_title<?php echo '_' .$k; ?>" >            
              <a id="action_amt_title_anchor<?php echo '_' .$k; ?>" class="title-anchors second-level-title" href="javascript:void(0);"><span class="showGetAsGet"><?php _e('Get Group Amount:', 'vtprd');?></span><span class="showGetAsDiscount"><?php _e('Discount Group Amount:', 'vtprd');?></span></a>
            </span>            
             <?php vtprd_show_help_tooltip($context = 'action_amt_title', $location = 'title'); ?>
             <span class="shortIntro" ><?php _e(' ...  "Buy a laptop, GET ONE mouse free "...', 'vtprd');?></span> 
              <a id="action-amt-title-more<?php echo '-' .$k; ?>" class="action-amt-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
              <a id="action-amt-title-less<?php echo '-' .$k; ?>" class="action-amt-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e(' ', 'vtprd'); ?> Less ...&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>                        
            <span class="dropdown action_amt clear-left" id="action_amt_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['action_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_amt_type']['option']); $i++) {
                          $this->vtprd_change_title_currency_symbol('action_amt_type', $i, $currency_symbol);                  
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['action_amt_type']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['action_amt_type'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>              
               <span class="action_amt_line_remainder  action_amt_line_remainder_class<?php echo '_' .$k; ?>" id="action_amt_line_remainder<?php echo '_' .$k; ?>">
                   <span class="amt-field action_amt_count" id="action_amt_count_pair<?php echo '_' .$k; ?>">
                     <span class="amt-field-label" id="action_amt_count_label<?php echo '_' .$k; ?>"> 
                          <span class="action_amt_count_literal  action_amt_count_literal<?php echo '_' .$k;?> " id="action_amt_count_literal_quantity<?php echo '_' .$k; ?>"><?php _e('Qty: ', 'vtprd');?> </span>
                          <span class="action_amt_count_literal  action_amt_count_literal<?php echo '_' .$k;?> " id="action_amt_count_literal_percent<?php echo '_' .$k; ?>"><?php _e('%: ', 'vtprd');?> </span>
                          <span class="action_amt_count_literal  action_amt_count_literal<?php echo '_' .$k;?> " id="action_amt_count_literal_currency<?php echo '_' .$k; ?>"><?php echo $currency_symbol . ':'; ?> </span>
                          <span class="action_amt_count_literal  action_amt_count_literal<?php echo '_' .$k;?> " id="action_amt_count_literal_nthQuantity<?php echo '_' .$k; ?>"><?php _e('Nth (number): ', 'vtprd');?> </span> 
                       </span>
                     <input id="<?php echo $vtprd_deal_screen_framework['action_amt_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['action_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['action_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_amt_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['action_amt_count']; ?>">
                   </span>                                                    
                   <span class="dropdown-label" id="action_amt_applies_to_label<?php echo '_' .$k; ?>">
                      <?php vtprd_show_help_tooltip($context = 'get-amt-applies-to', $location = 'title'); ?>
                      <?php _e('Amount Applies To: ', 'vtprd');?> 
                   </span>               
                   <select id="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['action_amt_applies_to']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['select']['tabindex']; ?>" >          
                     <?php
                     for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_amt_applies_to']['option']); $i++) { 
                     ?>                             
                        <option id="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['action_amt_applies_to']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['action_amt_applies_to'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['action_amt_applies_to']['option'][$i]['title']; ?> </option>
                     <?php } ?> 
                   </select>
               </span>                  
            </span>
          <?php vtprd_show_help_selection_panel_D($k); ?>
          <?php vtprd_show_help_selection_panel_E($k); ?>
        </div>
                    
        <div class="screen-box action_amt_mod_box  action_amt_mod_box_class<?php echo '_' .$k; ?>" id="action_amt_mod_box<?php echo '_' .$k; ?>" >
            <span class="title third-level-title" id="action_amt_mod_title<?php echo '_' .$k; ?>" >
               <a id="action_amt_mod_title_anchor<?php echo '_' .$k; ?>" class="title-anchors third-level-title" href="javascript:void(0);"><span class="showGetAsGet"><?php _e('Get Group Min/Max:', 'vtprd');?></span><span class="showGetAsDiscount"><?php _e('Discount Group Min/Max:', 'vtprd');?></span></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'action_amt_mod_title', $location = 'title'); ?>
            <span class="shortIntro" ><?php echo __(' ...  "Buy 5 tech items, Get a mouse free WHEN ITEM A MIN/MAX OF ', 'vtprd') .$currency_symbol. __('10 "...', 'vtprd'); ?></span>           
            <span class="dropdown  clear-left" id="action_amt_mod_dropdown<?php echo '_' .$k; ?>">
               <select id="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['select']['id'] . '_' .$k ; ?>" class="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_amt_mod']['option']); $i++) { 
                          $this->vtprd_change_title_currency_symbol('action_amt_mod', $i, $currency_symbol);                  
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_amt_mod']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['action_amt_mod']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['action_amt_mod'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['action_amt_mod']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>             
               <span class="amt-field  action_amt_mod_count_area  action_amt_mod_count_area_class<?php echo '_' .$k; ?>" id="action_amt_mod_count_area<?php echo '_' .$k; ?>">
                 <span class="amt-field-label" id="action_amt_mod_count_label<?php echo '_' .$k; ?>"> <?php echo $currency_symbol . ':'; ?> </span>
                 <input id="<?php echo $vtprd_deal_screen_framework['action_amt_mod_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['action_amt_mod_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['action_amt_mod_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_amt_mod_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['action_amt_mod_count']; ?>">
               </span>   
            </span>
         </div>

         <div class="screen-box action_group_box_class" id="action_group_box" >
            <span class="title" id="action_group_title">
              <a id="action_group_title_anchor" class="title-anchors second-level-title" href="javascript:void(0);"><span class="showGetAsGet"><?php _e('Get Group Filter::', 'vtprd');?></span><span class="showGetAsDiscount"><?php _e('Discount Group Filter:', 'vtprd');?></span></a>
            </span>
            <?php vtprd_show_help_tooltip($context = 'action-group-title', $location = 'title'); ?>            
             
            <span class="shortIntro" ><?php echo __(' ...  "Buy 5 .. GET 1 item .. Filtered By Category / Logged-in Status / Customer Category" ...', 'vtprd');?></span>             
            <a id="action-group-title-more" class="action-group-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
            <a id="action-group-title-less" class="action-group-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
          
            <span class="dropdown action_group clear-left" id="action_group_dropdown_0">              
               <select id="<?php echo $vtprd_rule_display_framework['actionPop']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['actionPop']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['actionPop']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['actionPop']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['actionPop']['option']); $i++) { 
                       
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['actionPop']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['actionPop']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['actionPop']['option'][$i]['title3'];                        
                      }                
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['actionPop']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['actionPop']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['actionPop']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['actionPop']['option'][$i]['value'] == $vtprd_rule->actionPop )  { echo $selected; } ?> >  <?php echo $title; ?> </option>
                 <?php } ?> 
               </select>             
               <span class="action_group_line_remainder_class" id="action_group_line_remainder">   
                <?php $this->vtprd_action_group_cntl(); ?> 
               </span>               
            </span>

                       
            <?php vtprd_show_help_selection_panel_J('0'); ?>
         </div>
         
         <div class="screen-box action_repeat_condition_box  action_repeat_condition_box_class<?php echo '_' .$k; ?>" id="action_repeat_condition_box<?php echo '_' .$k; ?>" >      <?php //Action repeat shifted to end of action area, although processed first ?> 
            <span class="title third-level-title" id="action_repeat_condition_title<?php echo '_' .$k; ?>" >
               <a id="action_repeat_condition_title_anchor<?php echo '_' .$k; ?>" class="title-anchors third-level-title" href="javascript:void(0);"><span class="showGetAsGet"><?php _e('Get Group Repeat:', 'vtprd');?></span><span class="showGetAsDiscount"><?php _e('Discount Group Repeat:', 'vtprd');?></span></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'action_repeat_condition_title', $location = 'title'); ?>
            <span class="shortIntro" ><?php echo __(' ...  "Buy 5 units get next one free, ONLY ONCE"...', 'vtprd') .'&nbsp;&nbsp;&nbsp;'.  __('(in this cart)"...', 'vtprd'); ;?></span>           
            <span class="dropdown action_repeat_condition clear-left"  id="action_repeat_condition_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['action_repeat_condition']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_repeat_condition']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_repeat_condition']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['action_repeat_condition']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['action_repeat_condition'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['action_repeat_condition']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>              
               <span class="amt-field action_repeat_count_area  action_repeat_count_area_class<?php echo '_' .$k; ?>" id="action_repeat_count_area<?php echo '_' .$k; ?>">
                 <?php vtprd_show_help_tooltip($context = 'action_repeat_condition_title'); ?>
                 <span class="amt-field-label" id="action_repeat_count_label<?php echo '_' .$k; ?>">                     
                    <?php _e('Count: ', 'vtprd');?> 
                 </span>
                 <input id="<?php echo $vtprd_deal_screen_framework['action_repeat_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['action_repeat_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['action_repeat_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['action_repeat_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['action_repeat_count']; ?>">                 
               </span>
           </span>
         </div>  
         
      </div> <?php //end  get_info display-virtual_box ?> 
        
      
      <?php //****************  
            //DISCOUNT INFO  
            //**************** ?>         
        <span class="box-border-line">&nbsp;</span>
        <div class="display-virtual_box" id="discount_info">
                 
          <div class="screen-box discount_amt_box  discount_amt_box_class<?php echo '_' .$k; ?>" id="discount_amt_box<?php echo '_' .$k; ?>" >  
            <span class="title" id="discount_amt_title<?php echo '_' .$k; ?>" >
              <img class="discount_amt_title_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />                            
              <a id="discount_amt_title_anchor<?php echo '_' .$k; ?>" class="section-headings first-level-title" href="javascript:void(0);"><?php _e('Discount Action:', 'vtprd');?></a>
            </span>
            <span class="title clear-both discount_action_type" id="discount_action_type_title<?php echo '_' .$k; ?>" >            
              <a id="discount_action_title_anchor<?php echo '_' .$k; ?>" class="title-anchors second-level-title" href="javascript:void(0);"><?php _e('Discount Action Type:', 'vtprd');?></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'discount_amt_title', $location = 'title'); ?>
            <span class="shortIntro" ><?php _e(' ...  "Buy 1, get 1 FREE "...', 'vtprd');?></span>               
              <a id="discount-amt-title-more<?php echo '-' .$k; ?>" class="discount-amt-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
              <a id="discount-amt-title-less<?php echo '-' .$k; ?>" class="discount-amt-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>              

            <span class="hide-discount-help">
              <a id="discount-amt-info-more" class="" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Checkout How-to &nbsp;-&nbsp; Discounts Show Automatically ', 'vtprd'); ?>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
              <a id="discount-amt-info-less" class="less-anchor" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Less Checkout Discount Display Help ... ', 'vtprd'); ?>&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>                              
            </span>
            <span class="dropdown discount_amt_type clear-left" id="discount_amt_type_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['discount_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['discount_amt_type']['option']); $i++) { 
                          $this->vtprd_change_title_currency_symbol('discount_amt_type', $i, $currency_symbol);                 
                  ?>                                                
                    <option id="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['discount_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['discount_amt_type']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['discount_amt_type'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['discount_amt_type']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select> 
               <span class="discount_amt_count_area  discount_amt_count_area_class<?php echo '_' .$k; ?>  amt-field" id="discount_amt_count_area<?php echo '_' .$k; ?>">    
                 <span class="amt-field-label" id="discount_amt_count_label<?php echo '_' .$k; ?>"> 
                    <span class="discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_quantity<?php echo '_' .$k; ?>"><?php _e('Qty: ', 'vtprd');?> </span>
                    <span class="discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_percent<?php echo '_' .$k; ?>"><?php _e('%: ', 'vtprd');?> </span>
                    <span class="discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_currency<?php echo '_' .$k; ?>"><?php echo $currency_symbol . ':'; ?> </span>
                    <span class="forThePriceOf-amt-literal-inserted  discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_forThePriceOf_buyAmt<?php echo '_' .$k; ?>"><?php $this->vtprd_load_forThePriceOf_literal($k); ?> </span>
                    <span class="discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_forThePriceOf<?php echo '_' .$k; ?>"><?php echo '&nbsp;'; _e('For the Price of: ', 'vtprd'); ?> </span>
                    <span class="discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?> " id="discount_amt_count_literal_forThePriceOf_Currency<?php echo '_' .$k; ?>"><?php echo $currency_symbol; ?></span>
                 </span>                 
                 <input id="<?php echo $vtprd_deal_screen_framework['discount_amt_count']['id'] . '_'  .$k; ?>" class="<?php echo $vtprd_deal_screen_framework['discount_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['discount_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_amt_count']['name'] . '_' .$k ; ?>" value="<?php echo $vtprd_rule->rule_deal_info[$k]['discount_amt_count']; ?>">                 
                 <span class="amt-field  discount_amt_count_literal  discount_amt_count_literal<?php echo '_' .$k;?>  discount_amt_count_literal_units_area  discount_amt_count_literal_units_area_class<?php echo '_' .$k; ?>" id="discount_amt_count_literal_units_area<?php echo '_' .$k; ?>">
                   <span class="amt-field-label" id="discount_amt_count_literal_units<?php echo '_' .$k; ?>"><?php _e(' units', 'vtprd');?> </span>
                   <?php vtprd_show_help_tooltip($context = 'discount_amt_count_forThePriceOf'); ?>
                 </span>                
               </span>
                <label id="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['label']['id'] . '_'  .$k; ?>"   class="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['label']['class'] ?>"> 
                    <input id="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['checkbox']['id'] . '_'  .$k; ?>" 
                          class="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['checkbox']['class']; ?>"
                          type="checkbox" 
                          value="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['checkbox']['value']; ?>" 
                           <?php if ($vtprd_deal_screen_framework['discount_auto_add_free_product']['checkbox']['value'] == $vtprd_rule->rule_deal_info[$k]['discount_auto_add_free_product'] )  { echo $checked; } ?>
                          name="<?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['checkbox']['name'] . '_'  .$k; ?>">
                    <?php echo $vtprd_deal_screen_framework['discount_auto_add_free_product']['label']['title']; ?>  
                    <?php vtprd_show_help_tooltip($context = 'discount_auto_add_free_product', $location = 'title'); ?> 
                </label>
                <?php vtprd_show_help_selection_panel_6(); //info about auto-add!!?>
               <span class="hide-discount-help">                
                <a id="discount-msgs-install-more" class="" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Cart Widget How-to ', 'vtprd'); echo '&nbsp;-&nbsp;'; _e(' Show Pricing Deal Discounts', 'vtprd'); ?>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
                <a id="discount-msgs-install-less" class="less-anchor" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Less Cart Widget Install Help ... ', 'vtprd'); ?>&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>                                                                        
               </span>
            </span>

            <?php vtprd_show_help_selection_panel_F($k); ?>
            <?php vtprd_show_help_selection_panel_1(); //special how-to panel...?>
            <?php vtprd_show_help_selection_panel_3(); ?>         
          </div> 
                  
          <div class="screen-box discount_applies_to_box  discount_applies_to_box_class<?php echo '_' .$k; ?>" id="discount_applies_to_box<?php echo '_' .$k; ?>" >
            <span class="title" id="discount_applies_to_title<?php echo '_' .$k; ?>" >
              <a id="discount_applies_to_title_anchor<?php echo '_' .$k; ?>" class="title-anchors second-level-title" href="javascript:void(0);"><?php _e('Discount Action Applies To:', 'vtprd');?></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'discount_applies_to', $location = 'title'); ?>
            <span class="shortIntro" ><?php _e(' ...  "Discount applies to: EACH ITEM singly / the WHOLE GROUP as a UNIT"...', 'vtprd');?></span>
              <a id="discount-applies-to-title-more<?php echo '-' .$k; ?>" class="discount-applies-to-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
              <a id="discount-applies-to-title-less<?php echo '-' .$k; ?>" class="discount-applies-to-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>               
                       
            <span class="dropdown discount_applies_to clear-left"  id="discount_applies_to_dropdown<?php echo '_' .$k; ?>">              
               <select id="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['select']['id'] . '_' .$k ; ?>" class="<?php echo$vtprd_deal_screen_framework['discount_applies_to']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['select']['name'] . '_' .$k ; ?>" tabindex="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['discount_applies_to']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['option'][$i]['id'] . '_'  .$k  ?>"  class="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['discount_applies_to']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['discount_applies_to']['option'][$i]['value'] == $vtprd_rule->rule_deal_info[$k]['discount_applies_to'] )  { echo $selected; } ?> >  <?php echo $vtprd_deal_screen_framework['discount_applies_to']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>                          
              </span>
            <?php vtprd_show_help_selection_panel_G($k); ?>  
          </div>
          
        
          <div class="screen-box discount_lifetime_max_amt_type clear-left" id="discount_lifetime_max_amt_type_box">  
             <?php
                 /* ***********************
                 special handling for  discount_lifetime_max_amt_type, discount_lifetime_max_amt_type.  Even though they appear iteratively in deal info,
                 they are only active on the '0' occurrence line.  further, they are displayed only AFTER all of the deal lines are displayed
                 onscreen... This is actually a kluge, done to utilize the complete editing already available in the deal info loop for a  dropdown and an associated amt field.
                 *********************** */
             
               //Both _label fields have trailing '_0', as edits are actually handled in the discount info loop ?>          
            <span class="title" id="discount_lifetime_max_title_0" >
              <a id="discount_lifetime_max_title_anchor" class="title-anchors second-level-title" href="javascript:void(0);"><?php _e('Per Customer Limit:', 'vtprd');?></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'discount_lifetime_max_amt_type', $location = 'title'); ?>
            <span class="shortIntro" ><?php echo __(' ... "ONE DISCOUNT PER CUSTOMER ...', 'vtprd'); ?></span>
              <a id="discount-lifetime-max-title-more-0" class="discount-lifetime-max-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
              <a id="discount-lifetime-max-title-less-0" class="discount-lifetime-max-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>              
                       
            <span class="dropdown  clear-left" id="discount_lifetime_max_dropdown">
               <select id="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['select']['id'] .'_0' ;?>" class="<?php echo$vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['select']['name'] .'_0' ;?>" tabindex="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['select']['tabindex'] .'_0' ; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option']); $i++) { 
                          $this->vtprd_change_title_currency_symbol('discount_lifetime_max_amt_type', $i, $currency_symbol);
                      
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['title3'];                        
                      }          
                                                            
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['id'] .'_0' ;?>"  class="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['discount_lifetime_max_amt_type']['option'][$i]['value']  == $vtprd_rule->rule_deal_info[0]['discount_lifetime_max_amt_type']  )  { echo $selected; } // use '0' deal_info_line...?> >  <?php echo $title; ?> </option>
                 <?php } ?> 
               </select>            
               <span class="amt-field" id="discount_lifetime_max_amt_count_area">
                  <span class="amt-field-label" id="discount_lifetime_max_amt_count_label_0">
                      <span class="discount_lifetime_max_amt_count_literal" id="discount_lifetime_max_amt_count_literal_quantity"><?php _e('Count: ', 'vtprd');?> </span>                         
                      <span class="discount_lifetime_max_amt_count_literal" id="discount_lifetime_max_amt_count_literal_currency"><?php echo $currency_symbol . ':'; ?> </span>                                                                                  
                  </span>
                 <input id="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_count']['id'] .'_0' ?>" class="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_lifetime_max_amt_count']['name'] .'_0' ;?>" value="<?php echo $vtprd_rule->rule_deal_info[0]['discount_lifetime_max_amt_count']; // use '0' deal_info_line...?>">
               </span>
            </span>
             <?php vtprd_show_help_selection_panel_I('0'); ?>
             <span class="text-field  clear-left" id="discount_lifetime_max_amt_msg">
               <span class="data-line-indent">&nbsp;</span>
               <span class="text-field-label" id="discount_lifetime_max_amt_msg_label"> <?php _e('Short Message When Max Applied (opt): ', 'vtprd');?> </span>
                <?php vtprd_show_help_tooltip($context = 'discount_lifetime_max_amt_msg'); ?>
               <textarea rows="1" cols="100" id="<?php echo $vtprd_rule_display_framework['discount_lifetime_max_amt_msg']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['discount_lifetime_max_amt_msg']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['discount_lifetime_max_amt_msg']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['discount_lifetime_max_amt_msg']['name']; ?>" ><?php echo $vtprd_rule->discount_lifetime_max_amt_msg; ?></textarea>
             </span>           
          </div> 
                   
                    
          
                  
        </div> 
      <?php //****************  
            //end  DISCOUNT INFO  display-virtual_box 
            //**************** ?>   
        
        </div> <?php //end DEAL INFO line in "for" loop ?>   
      <?php } ?>
      </div> <?php //end rule_deal_info_group ?>  
      
      <span class="box-border-line">&nbsp;</span>
      <div id="messages-outer-box">           
         <div class="screen-box  messages-box_class" id="messages-box">
           <span class="title" id="discount_msgs_title" >
              <img class="theme_msgs_title_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />                                          
              <a id="discount_msgs_title_anchor" class="section-headings first-level-title" href="javascript:void(0);"><?php _e('Theme and Checkout Messages:', 'vtprd');?></a>            
           </span>
           <a id="discount-shortcodes-more" class="" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Add Messages to your Theme using Shortcodes!', 'vtprd'); ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
           <a id="discount-shortcodes-less" class="less-anchor" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Less Shortcodes Help ... ', 'vtprd'); ?>&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
           <span class="dropdown messages-box-area clear-left"  id="discount_msgs_dropdown">
             <span class="discount_product_full_msg_area clear-both">
               <span class="text-field" id="discount_product_full_msg_line">
                 <span class="text-field-label" id="discount_product_full_msg_label"> <?php _e('Discount Theme Message: ', 'vtprd');?> </span>
                 <?php vtprd_show_help_tooltip($context = 'discount_full_msg'); ?>
                  <a id="discount-msgs-info-more" class="" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Add "You Save" and "Old Price" Realtime Rule Info ', 'vtprd'); ?>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>            
                  <a id="discount-msgs-info-less" class="less-anchor" href="javascript:void(0);"><img width="10" height="10" src="<?php echo VTPRD_URL;?>/admin/images/help.png" alt="help"><?php _e(' Less Realtime Messages Use Help ... ', 'vtprd'); ?>&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>                                
                 <textarea rows="1" cols="100" id="<?php echo $vtprd_rule_display_framework['discount_product_full_msg']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['discount_product_full_msg']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['discount_product_full_msg']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['discount_product_full_msg']['name']; ?>" ><?php echo $vtprd_rule->discount_product_full_msg; ?></textarea> 
               </span>                                                                                                               
             </span>
             <span class="discount_product_short_msg_area  clear-left">
               <span class="text-field" id="discount_product_short_msg_line">
                 <span class="text-field-label" id="discount_product_short_msg_label"> <?php _e('Discount Checkout Message (short): ', 'vtprd');?> </span>
                 <?php vtprd_show_help_tooltip($context = 'discount_short_msg'); ?>
                 <textarea rows="1" cols="60" id="<?php echo $vtprd_rule_display_framework['discount_product_short_msg']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['discount_product_short_msg']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['discount_product_short_msg']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['discount_product_short_msg']['name']; ?>" ><?php echo $vtprd_rule->discount_product_short_msg; ?></textarea>
               </span>
             </span> 
           </span>
           <?php vtprd_show_help_selection_panel_4(); ?>
           <?php vtprd_show_help_selection_panel_2(); ?>
         </div>    
      </div>
       
      
      <span class="box-border-line">&nbsp;</span>
      <span class="title advanced-area">
        <img class="advanced_area_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />                                                        
        <span id="advanced-title"><?php _e('ADVANCED AREA', 'vtprd');?></span><span id="advanced-subtitle"><?php _e('(optional)', 'vtprd');?></span>
      </span>       
    
    <div id="advanced-data-area"> 
      <div class="screen-box" id="cumulativePricing_box">     
          <span class="title" id="cumulativePricing_title" >
            <img class="working_together_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />                                                        
            <a id="cumulativePricing_title_anchor" class="section-headings first-level-title" href="javascript:void(0);"><?php _e('Discounts Working Together:', 'vtprd');?></a>
          </span>
            <?php vtprd_show_help_tooltip($context = 'cumulative_pricing_switches', $location = 'title'); ?>
          <span class="shortIntro" ><?php _e(' ... CONTROL MULTIPLE DISCOUNTS being applied at the same time ...', 'vtprd');?></span>           
          <div class="clear-left" id="cumulativePricing_dropdown">       
            <div class="dropdown cumulativeRulePricing_area clear-left" id="cumulativeRulePricing_areaID"> 
               <span class="text-field-label cumulativeRulePricing_lit" id="cumulativeRulePricing_label"><?php _e('Apply this Rule Discount ', 'vtprd'); echo '&nbsp;&nbsp;';  _e('in Addition to Other Cart Rule Discounts : &nbsp;', 'vtprd');?></span>               
               <select id="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['cumulativeRulePricing']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['cumulativeRulePricing']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['cumulativeRulePricing']['option'][$i]['value'] == $vtprd_rule->cumulativeRulePricing )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['cumulativeRulePricing']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>
               <?php vtprd_show_help_tooltip($context = 'cumulativeRulePricing'); ?>
               <span class="" id="priority_num">   <?php //only display if multiple rule discounts  ?>
                 <span class="text-field" id="ruleApplicationPriority_num">
                   <span class="text-field-label" id="ruleApplicationPriority_num_label"> <?php _e('Rule Priority Sort Number:', 'vtprd');?> </span>
                   <input id="<?php echo $vtprd_rule_display_framework['ruleApplicationPriority_num']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['ruleApplicationPriority_num']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['ruleApplicationPriority_num']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['ruleApplicationPriority_num']['name']; ?>" value="<?php echo $vtprd_rule->ruleApplicationPriority_num; ?>">
                 </span>
                 <?php vtprd_show_help_tooltip($context = 'ruleApplicationPriority_num'); ?>
               </span>             
            </div>
    
            <div class="dropdown cumulativeCouponPricing_area clear-left" id="cumulativeCouponPricing_0">              
               <span class="text-field-label cumulativeRulePricing_lit" id="cumulativeCouponPricing_label"><?php _e('Apply this Rule Discount ', 'vtprd'); echo '&nbsp;&nbsp;';  _e('in Addition to Coupon Discount : &nbsp;', 'vtprd');?></span>               
               <select id="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['cumulativeCouponPricing']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['cumulativeCouponPricing']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['cumulativeCouponPricing']['option'][$i]['value'] == $vtprd_rule->cumulativeCouponPricing )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['cumulativeCouponPricing']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select>
               <?php vtprd_show_help_tooltip($context = 'cumulativeCouponPricing'); ?> 
            </div>
                 
            <div class="dropdown cumulativeSalePricing_area clear-left" id="cumulativeSalePricing_areaID">              
               <span class="text-field-label cumulativeRulePricing_lit" id="cumulativeSalePricing_label"><?php _e('Apply this Rule Discount ', 'vtprd'); echo '&nbsp;&nbsp;';  _e('to Product Sale Pricing : &nbsp;', 'vtprd');?></span> 
                <?php if (VTPRD_PARENT_PLUGIN_NAME == 'WP E-Commerce') { vtprd_show_help_tooltip($context = 'cumulativeSalePricingLimitation');  } ?>              
               <select id="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['cumulativeSalePricing']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['cumulativeSalePricing']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['option'][$i]['value']; ?>"   <?php if ($vtprd_rule_display_framework['cumulativeSalePricing']['option'][$i]['value'] == $vtprd_rule->cumulativeSalePricing )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['cumulativeSalePricing']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
               </select> 
               <?php vtprd_show_help_tooltip($context = 'cumulativeSalePricing'); ?>
            </div>
          </div>  <?php //end cumulativeRulePricing_dropdown ?>  
       </div> <?php //end cumulativePricing box ?>  
      
      <span class="box-border-line">&nbsp;</span> 
            
      <div class="screen-box" id="maximums_box">   
          <span class="title" id="cumulativePricing_title" >
            <img class="maximums_icon" src="<?php echo VTPRD_URL;?>/admin/images/tab-icons.png" width="1" height="1" />                                                        
            <a id="cumulativePricing_title_anchor" class="section-headings first-level-title" href="javascript:void(0);">
                <?php _e('Limits:', 'vtprd');?>
                <?php if (!defined('VTPRD_PRO_DIRNAME'))  {  ?>
                    <span id="max-limits-subtitle"><?php _e('(pro only)', 'vtprd');?></span>
                <?php }  ?>
            </a>
          </span>
           
        <div class="dropdown discount_rule_max_amt_type clear-left" id="discount_rule_max_amt_type_box">  
             <?php
                 /* ***********************
                 special handling for  discount_rule_max_amt_type, discount_rule_max_amt_type.  Even though they appear iteratively in deal info,
                 they are only active on the '0' occurrence line.  further, they are displayed only AFTER all of the deal lines are displayed
                 onscreen... This is actually a kluge, done to utilize the complete editing already available in the deal info loop for a  dropdown and an associated amt field.
                 *********************** */
             
               //Both _label fields have trailing '_0', as edits are actually handled in the discount info loop ?>          
            <span class="title" id="discount_rule_max_title_0" >
              <a id="discount_rule_max_title_anchor" class="title-anchors second-level-title" href="javascript:void(0);"><?php _e('Discount Maximum for Rule:', 'vtprd');?></a>
            </span>
              <?php vtprd_show_help_tooltip($context = 'discount_rule_max_amt_type', $location = 'title'); ?>
            <span class="shortIntro" ><?php echo __(' ... "Buy 5 laptops, get a discount, MAX DISCOUNT VALUE OF ', 'vtprd')  .$currency_symbol. __('30"...', 'vtprd'); ?></span>  
              <a id="discount-rule-max-title-more-0" class="discount-rule-max-title-more more-anchor" href="javascript:void(0);"><span class="context-help"><?php _e('Context Help', 'vtprd'); ?></span>&nbsp;<img class="plus-button" alt="help" height="10px" width="10px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
              <a id="discount-rule-max-title-less-0" class="discount-rule-max-title-less more-anchor less-anchor" href="javascript:void(0);"><?php _e('  Less ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>              
                       
            <span class="dropdown clear-left" id="discount_rule_max_dropdown">
                <select id="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['select']['id'] .'_0' ;?>" class="<?php echo$vtprd_deal_screen_framework['discount_rule_max_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['select']['name'] .'_0' ;?>" tabindex="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['select']['tabindex'] .'_0' ; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['discount_rule_max_amt_type']['option']); $i++) {
                          $this->vtprd_change_title_currency_symbol('discount_rule_max_amt_type', $i, $currency_symbol); 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['option'][$i]['id'] .'_0' ;?>"  class="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['discount_rule_max_amt_type']['option'][$i]['value']  == $vtprd_rule->rule_deal_info[0]['discount_rule_max_amt_type']  )  { echo $selected; } // use '0' deal_info_line...?> >  <?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_type']['option'][$i]['title']; ?> </option>
                 <?php } ?> 
                </select> 
                <span class="amt-field  " id="discount_rule_max_amt_count_area">
                  <span class="amt-field-label" id="discount_rule_max_amt_count_label_0"> 
                      <span class="discount_rule_max_amt_count_literal" id="discount_rule_max_amt_count_literal_quantity"><?php _e('Count: ', 'vtprd');?> </span> 
                      <span class="discount_rule_max_amt_count_literal" id="discount_rule_max_amt_count_literal_percent"><?php echo '%: ';?> </span>                          
                      <span class="discount_rule_max_amt_count_literal" id="discount_rule_max_amt_count_literal_currency"><?php echo $currency_symbol . ':'; ?> </span>                                  
                  </span>
                 <input id="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_count']['id'] .'_0' ?>" class="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_rule_max_amt_count']['name'] .'_0' ;?>" value="<?php echo $vtprd_rule->rule_deal_info[0]['discount_rule_max_amt_count']; // use '0' deal_info_line...?>">
                </span>
            </span>
           <?php vtprd_show_help_selection_panel_H('0'); ?>
           <?php //while the 2 max_amt fields above are kluged onto the deal_screen_framework, the msg field is on the rule proper ?>
           <span class="text-field  clear-left" id="discount_rule_max_amt_msg">
             <span class="data-line-indent">&nbsp;</span>
             <span class="text-field-label" id="discount_rule_max_amt_msg_label"> <?php _e('Short Message When Max Applied (opt): ', 'vtprd');?> </span>
              <?php vtprd_show_help_tooltip($context = 'discount_rule_max_amt_msg'); ?>
             <textarea rows="1" cols="100" id="<?php echo $vtprd_rule_display_framework['discount_rule_max_amt_msg']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['discount_rule_max_amt_msg']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['discount_rule_max_amt_msg']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['discount_rule_max_amt_msg']['name']; ?>" ><?php echo $vtprd_rule->discount_rule_max_amt_msg; ?></textarea>
           </span>           
        </div>     
  
            <div class="dropdown discount_rule_cum_max_amt_type clear-left" id="discount_rule_cum_max_amt_type_box">  
                 <?php
                     /* ***********************
                     special handling for  discount_rule_cum_max_amt_type, discount_rule_cum_max_amt_type.  Even though they appear iteratively in deal info,
                     they are only active on the '0' occurrence line.  further, they are displayed only AFTER all of the deal lines are displayed
                     onscreen... This is actually a kluge, done to utilize the complete editing already available in the deal info loop for a  dropdown and an associated amt field.
                     *********************** */
                 
                   //Both _label fields have trailing '_0', as edits are actually handled in the discount info loop ?>          
                <span class="title title-anchors second-level-title" id="discount_rule_cum_max_title_0" ><?php _e('Discount per Product Maximum:', 'vtprd');?></span>
                    <?php vtprd_show_help_tooltip($context = 'discount_rule_cum_max_amt_type', $location = 'title'); ?>
                <span class="shortIntro" ><?php echo __(' ... "GET A PRODUCT MAX DISCOUNT VALUE OF ', 'vtprd') .$currency_symbol.  __('30 ACROSS ALL RULES FOR THIS CART"...', 'vtprd'); ?></span>           
                <span class="dropdown clear-left" id="discount_rule_cum_max_dropdown">                                                         
                   <select id="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['select']['id'] .'_0' ;?>" class="<?php echo$vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['select']['class']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['select']['name'] .'_0' ;?>" tabindex="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['select']['tabindex'] .'_0' ; ?>" >          
                     <?php
                     for($i=0; $i < sizeof($vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option']); $i++) { 
                              $this->vtprd_change_title_currency_symbol('discount_rule_cum_max_amt_type', $i, $currency_symbol);             
                     ?>                             
                        <option id="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option'][$i]['id'] .'_0' ;?>"  class="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option'][$i]['value']; ?>"   <?php if ($vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option'][$i]['value']  == $vtprd_rule->rule_deal_info[0]['discount_rule_cum_max_amt_type']  )  { echo $selected; } // use '0' deal_info_line...?> >  <?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_type']['option'][$i]['title']; ?> </option>
                     <?php } ?> 
                   </select> 
                   <span class="amt-field" id="discount_rule_cum_max_amt_count_area">
                      <span class="amt-field-label" id="discount_rule_cum_max_amt_count_label_0"> 
                          <span class="discount_rule_cum_max_amt_count_literal" id="discount_rule_cum_max_amt_count_literal_quantity"><?php _e('Qty: ', 'vtprd');?> </span> 
                          <span class="discount_rule_cum_max_amt_count_literal" id="discount_rule_cum_max_amt_count_literal_percent"><?php echo '%: ';?> </span>                          
                          <span class="discount_rule_cum_max_amt_count_literal" id="discount_rule_cum_max_amt_count_literal_currency"><?php echo $currency_symbol . ':'; ?> </span>                                  
                      </span>              
                     <input id="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_count']['id'] .'_0' ?>" class="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_count']['class']; ?>" type="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_count']['type']; ?>" name="<?php echo $vtprd_deal_screen_framework['discount_rule_cum_max_amt_count']['name'] .'_0' ;?>" value="<?php echo $vtprd_rule->rule_deal_info[0]['discount_rule_cum_max_amt_count']; // use '0' deal_info_line...?>">
                   </span>
                </span>
               <span class="text-field  clear-left" id="discount_rule_cum_max_amt_msg">
                 <span class="data-line-indent">&nbsp;</span>
                 <span class="text-field-label" id="discount_rule_cum_max_amt_msg_label"> <?php _e('Short Message When Max Applied (opt): ', 'vtprd');?> </span>
                  <?php vtprd_show_help_tooltip($context = 'discount_rule_cum_max_amt_msg'); ?>
                 <textarea rows="1" cols="100" id="<?php echo $vtprd_rule_display_framework['discount_rule_cum_max_amt_msg']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['discount_rule_cum_max_amt_msg']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['discount_rule_cum_max_amt_msg']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['discount_rule_cum_max_amt_msg']['name']; ?>" ><?php echo $vtprd_rule->discount_rule_cum_max_amt_msg; ?></textarea>
               </span>
            </div>                
          
      </div> <?php //end maximums_box box ?>                      

      </div> <?php //end advanced-data-area ?>
            
      </div> <?php //lower-screen-wrapper ?>
      
      <?php 
          
    //lots of selects change their values between standard and 'discounted' titles.
    //This is where we supply the HIDEME alternative titles
    $this->vtprd_print_alternative_title_selects();       
  } 
      
   public    function vtprd_buy_action_groups() {      
       $this->vtprd_buy_group_cntl();
       $this->vtprd_action_group_cntl();                
}
      
  
    public    function vtprd_buy_group_cntl() {   
       global $post, $vtprd_info, $vtprd_rule, $vtprd_rule_display_framework, $vtprd_rules_set;
       $selected = 'selected="selected"';
       $checked = 'checked="checked"';  
     ?>
                          
        <span class="amt-field" id="singleChoiceIn-span">                                  
          <span class="amt-field-label" id="singleProdID-in-label"><span class="showBuyAsBuy"><?php _e('Buy Product ID Number:', 'vtprd');?></span><span class="showBuyAsDiscount"><?php _e('Discount Product ID Number:', 'vtprd');?></span></span>
          <input id="<?php echo $vtprd_rule_display_framework['inPop_singleProdID']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['inPop_singleProdID']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['inPop_singleProdID']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['inPop_singleProdID']['name']; ?>" value="<?php echo $vtprd_rule->inPop_singleProdID; ?>">
          <?php vtprd_show_help_tooltip($context = 'pop-prod-id', $location = 'title'); ?>
          
          <?php if ($vtprd_rule->inPop_singleProdID['value'] > ' ' ) { ?>           
              <span class="clear-left" id="singleProdID-in-name-area">
                <span class="amt-field-label" id="singleProdID-in-name-label"><?php _e('Buy Product Name:', 'vtprd');?></span>
                <span id="singleProdID-in-name" ><?php echo $vtprd_rule->inPop_singleProdID_name; ?></span>
              </span>
          <?php } ?>                                                     
        </span> 
               
         
        <div id="inPop-varProdID-cntl">            
          <a id="inPop-varProdID-more" class="help-anchor" href="javascript:void(0);"><?php _e('Buy Single Product with Variations - ', 'vtprd');?><span id="pop-in-more-help">More Info</span></a>
         <p id="inPop-varProdID-descrip" class="help-text"><?php _e('When "Single Product with Variations" is chosen, at least one variation must be selected.
         <br><br> NB - PLEASE NOTE: If the product variation structure is changed in any way, you MUST return to the matching rule and reselect your variation choices.
         <br><br>Multiple rules may be created to apply to individual variations, or groups of variations within a product.           
         <br><br>Please be sure to prevent any rule overlap when applied to a given
            product-variation combination.  An overlap example: if there is a category-level rule covering an entire product, and an individual rule applying to any of the product variations.
         <br><br>Rule overlap in variation rules is Not removed by the rule processing engine, it must be prevented here.'   , 'vtprd');?>             
         </p> 
          <div id="inPopVarBox">
              <h3 id="inPopVarBox_label"><?php _e('Single Product with Variations', 'vtprd');?>
                  <?php vtprd_show_help_tooltip($context = 'pop-prod-id', $location = 'title'); ?>
              </h3>
              <div id="inPopVarProduct">
                <span id="varProdID-in-label">&nbsp;&nbsp;<?php _e('Enter "Buy" Product ID Number', 'vtprd');?></span><br />                                    
                  <input id="<?php echo $vtprd_rule_display_framework['inPop_varProdID']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['inPop_varProdID']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['inPop_varProdID']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['inPop_varProdID']['name']; ?>" value="<?php echo $vtprd_rule->inPop_varProdID; ?>">
                 <br />                            
              </div>
              <div id="inPopVarButton">
                 <?php
                    $product_ID = $vtprd_rule->inPop_varProdID['value']; 
                    $product_variation_IDs = vtprd_get_variations_list($product_ID);
                    /* ************************************************
                    **   Get Variations Button for Rule screen
                    *     ==>>> get the product id from $_REQUEST['varProdID'];  in the receiving ajax routine. 
                    ************************************************ */                     
                 ?>
                                                        
                 <div class="inPopVar-loading-animation">
										<img title="Loading" alt="Loading" src="<?php echo VTPRD_URL;?>/admin/images/indicator.gif" />
										<?php _e('Getting Variations ...', 'vtprd'); ?>
								 </div>
                 
                 
                 <a id="ajaxVariationIn" href="javascript:void(0);">
                    <?php if ($product_ID > ' ') {   ?>
                      <?php _e('Refresh Variations', 'vtprd');?>                      
                    <?php } else {   ?>
                      <?php _e('Get Variations', 'vtprd');?> 
                    <?php } ?>
                  </a>
                 
              </div>
          </div>
          <div id="variations-in">
          <?php              
           if ($product_variation_IDs) { //if product still has variations, expose them here
           ?>
              <h3><?php _e('Product Variations', 'vtprd');?></h3>                  
            <?php
              //********************************
              $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'variations', 'tax_class' => 'var-in', 'checked_list' => $vtprd_rule->var_in_checked, 'pop_in_out_sw' => 'in', 'product_ID' => $product_ID, 'product_variation_IDs' => $product_variation_IDs )));
              // ********************************                            
            }                               
          ?>
            <?php //output hidden count of all variation checkboxes.  Used on update to store info used in 'yousave' messaging?>
            <input type="hidden" id="checkbox_count-var-in" name="checkbox_count-var-in" value="<?php echo $vtprd_info['inpop_variation_checkbox_total']; ?>" />
           </div>  <?php//end variations-in ?>
        </div>  <?php //end inPopVarProdID ?> 
        
        <div class="" id="vtprd-pop-in-groups-cntl-help"> 
          <a id="groupsPop-in-more" class="groupsPop-help-in  more-anchor  hideMe" href="javascript:void(0);"><?php _e(' Selection Groups - More info (Context Help)...', 'vtprd'); ?>&nbsp;&nbsp;<img class="plus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
          <a id="groupsPop-in-less" class="groupsPop-help-in  more-anchor less-anchor  hideMe" href="javascript:void(0);"><?php _e(' Selection Groups - Less info ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
        </div>
        
        <div class="" id="vtprd-pop-in-groups-cntl">             
        <div class="<?php //echo $groupPop_vis ?> " id="vtprd-pop-in-cntl">                                                           
         <?php vtprd_show_help_selection_panel_K(); ?>
        <div  class="clear-left" id="prodcat-in">
          <h3 id="prodcat-in-label"><?php _e('Product Categories', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => $vtprd_info['parent_plugin_taxonomy'], 'tax_class' => 'prodcat-in', 'checked_list' => $vtprd_rule->prodcat_in_checked, 'pop_in_out_sw' => 'in')));
          // ********************************
          ?>
        
        </div>  <?php//end prodcat-in ?>
        <h4 class="and-or" id="and-or-in-label"><?php _e('Or', 'vtprd') //('And / Or', 'vtprd');?></h4>
        <div id="rulecat-in">
          <h3 id="rulecat-in-label"><?php _e('Pricing Deals Categories', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => $vtprd_info['rulecat_taxonomy'], 'tax_class' => 'rulecat-in', 'checked_list' => $vtprd_rule->rulecat_in_checked , 'pop_in_out_sw' => 'in' )));
          // ********************************
          ?> 
                         
        </div>  <?php//end rulecat-in ?>
        
        
        <div id="and-or-role-div">
          <?php
           for($i=0; $i < sizeof($vtprd_rule_display_framework['role_and_or_in']); $i++) { 
           ?>                               
              <input id="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['id']; ?>" class="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['class']; ?>" type="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['type']; ?>" name="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['name']; ?>" value="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['value']; ?>" <?php if ( $vtprd_rule_display_framework['role_and_or_in'][$i]['value'] == $vtprd_rule->role_and_or_in) { echo $checked; } ?>    /><span id="<?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['id'] . '-label'; ?>"> <?php echo $vtprd_rule_display_framework['role_and_or_in'][$i]['label']; ?></span><br /> 
           <?php } 
           //if neither 'and' nor 'or' selected, select 'or'
         /*  if ( (!$vtprd_rule_display_framework['role_and_or_in'][0]['user_input'] == 's') && (!$vtprd_rule_display_framework['role_and_or_in'][1]['user_input'] == 's') )   {
               $vtprd_rule_display_framework['role_and_or_in'][1]['user_input'] = 's';
           }   */
                      
           ?>                 
          </div>
        
        
        <div id="role-in">
          <h3 id="role-in-label"><?php _e('Role (Membership / Wholesaler)', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'roles', 'tax_class' => 'role-in', 'checked_list' => $vtprd_rule->role_in_checked  )));
          // ********************************
          ?>
        </div>
        
       </div> <?php //end vtprd-pop-in-groups-cntl ?>  
       </div> <?php //end vtprd-pop-in-cntl ?>  
      
    <?php
 
}
      

                                                                            
    public    function vtprd_action_group_cntl() { 
       global $post, $vtprd_info, $vtprd_rule, $vtprd_rule_display_framework, $vtprd_rules_set;
       $selected = 'selected="selected"';
       $checked = 'checked="checked"';       
    ?>                                             

        <span class="amt-field" id="singleChoiceOut-span">                                  
          <span class="amt-field-label" id="singleProdID-out-label"><?php _e('Discount Product ID Number', 'vtprd');?></span>                    
            <input id="<?php echo $vtprd_rule_display_framework['actionPop_singleProdID']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['actionPop_singleProdID']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['actionPop_singleProdID']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['actionPop_singleProdID']['name']; ?>" value="<?php echo $vtprd_rule->actionPop_singleProdID; ?>">
            <?php vtprd_show_help_tooltip($context = 'pop-prod-id', $location = 'title'); ?>
          
          <?php if ($vtprd_rule->actionPop_singleProdID['value'] > ' ' ) { ?>           
              <span class="clear-left" id="singleProdID-out-name-area">
                <span class="amt-field-label"  id="singleProdID-out-name-label"><?php _e('Discount Product Name:', 'vtprd'); ?></span>
                <span id="singleProdID-out-name" ><?php echo $vtprd_rule->actionPop_singleProdID_name; ?></span>
              </span>
          <?php } ?>                                                
        </span>
          
        <!-- </div> -->       

         
        <div id="actionPop-varProdID-cntl">            
          <a id="actionPop-varProdID-more" class="help-anchor" href="javascript:void(0);"><?php _e('Single Product with Variations - ', 'vtprd');?><span id="pop-out-more-help">More Info</span></a>
         <p id="actionPop-varProdID-descrip" class="help-text"><?php _e('When "Single Product with Variations" is chosen, at least one variation must be selected.
         <br><br> NB - PLEASE NOTE: If the product variation structure is changed in any way, you MUST return to the matching rule and reselect your variation choices.
         <br><br>Multiple rules may be created to apply to individual variations, or groups of variations within a product.           
         <br><br>Please be sure to prevent any rule overlap when applied to a given
            product-variation combination.  An overlap example: if there is a category-level rule covering an entire product, and an individual rule applying to any of the product variations.
         <br><br>Rule overlap in variation rules is Not removed by the rule processing engine, it must be prevented here.'   , 'vtprd');?>             
         </p> 
          <div id="actionPopVarBox">
              <h3 id="actionPopVarBox_label"><?php _e('Single Product with Variations', 'vtprd');?>
                  <?php vtprd_show_help_tooltip($context = 'pop-prod-id', $location = 'title'); ?>
              </h3>
              <div id="actionPopVarProduct">
                <span id="varProdID-out-label">&nbsp;&nbsp;<?php _e('Enter Discount Product ID Number', 'vtprd');?></span><br />                    
                  <input id="<?php echo $vtprd_rule_display_framework['actionPop_varProdID']['id']; ?>" class="<?php echo $vtprd_rule_display_framework['actionPop_varProdID']['class']; ?>" type="<?php echo $vtprd_rule_display_framework['actionPop_varProdID']['type']; ?>" name="<?php echo $vtprd_rule_display_framework['actionPop_varProdID']['name']; ?>" value="<?php echo $vtprd_rule->actionPop_varProdID; ?>">
                 <br />                            
              </div>
              <div id="actionPopVarButton">
                 <?php
                    $product_ID = $vtprd_rule->actionPop_varProdID['value']; 
                    $product_variation_IDs = vtprd_get_variations_list($product_ID);
                    /* ************************************************
                    **   Get Variations Button for Rule screen
                    *     ==>>> get the product id from $_REQUEST['varProdID'];  in the receiving ajax routine. 
                    ************************************************ */                     
                 ?>
                                                        
                 <div class="actionPopVar-loading-animation">
										<img title="Loading" alt="Loading" src="<?php echo VTPRD_URL;?>/admin/images/indicator.gif" />
										<?php _e('Getting Variations ...', 'vtprd'); ?>
								 </div>
                 
                 
                 <a id="ajaxVariationOut" href="javascript:void(0);">
                    <?php if ($product_ID > ' ') {   ?>
                      <?php _e('Refresh Variations', 'vtprd');?>                      
                    <?php } else {   ?>
                      <?php _e('Get Variations', 'vtprd');?> 
                    <?php } ?>
                  </a>
                 
              </div>
          </div>
          <div id="variations-out">
          <?php              
           if ($product_variation_IDs) { //if product still has variations, expose them here
           ?>
              <h3><?php _e('Product Variations', 'vtprd');?></h3>                  
            <?php
              //********************************
              $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'variations', 'tax_class' => 'var-out', 'checked_list' => $vtprd_rule->var_out_checked, 'pop_in_out_sw' => 'out', 'product_ID' => $product_ID, 'product_variation_IDs' => $product_variation_IDs )));
              // ********************************
            }                               
          ?>
           </div>  <?php//end variations-out ?>
        </div>  <?php //end actionPopVarProdID ?> 
        
        <div class="" id="vtprd-pop-out-cntl-help">                  
          <a id="groupsPop-out-more" class="groupsPop-help-out  more-anchor  hideMe" href="javascript:void(0);"><?php _e(' Selection Groups - More info (Context Help) ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="plus-button" alt="help" height="12px" width="12px"  src="<?php echo VTPRD_URL;?>/admin/images/plus-toggle2.png" /></a>
          <a id="groupsPop-out-less" class="groupsPop-help-out  more-anchor less-anchor  hideMe" href="javascript:void(0);"><?php _e(' Selection Groups - Less info ...', 'vtprd'); ?>&nbsp;&nbsp;<img class="minus-button" alt="help" height="12px" width="12px" src="<?php echo VTPRD_URL;?>/admin/images/minus-toggle2.png" /></a>
        </div>  
         
        <div class="" id="vtprd-pop-out-cntl">                                                  
         <?php vtprd_show_help_selection_panel_L(); ?>
    
        <div class="clear-left" id="prodcat-out">
          <h3><?php _e('Product Categories', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => $vtprd_info['parent_plugin_taxonomy'], 'tax_class' => 'prodcat-out', 'checked_list' => $vtprd_rule->prodcat_out_checked, 'pop_in_out_sw' => 'out')));
          // ********************************
          ?>
        
        </div>  <?php//end prodcat-out ?>
        <h4 class="and-or"><?php _e('Or', 'vtprd') //('And / Or', 'vtprd');?></h4>
        <div id="rulecat-out">
          <h3><?php _e('Pricing Deals Categories', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => $vtprd_info['rulecat_taxonomy'], 'tax_class' => 'rulecat-out', 'checked_list' => $vtprd_rule->rulecat_out_checked , 'pop_in_out_sw' => 'out')));
          // ********************************
          ?> 
                         
        </div>  <?php//end rulecat-out ?>
        
        
        <div id="and-or-role-div">
          <?php
           for($i=0; $i < sizeof($vtprd_rule_display_framework['role_and_or_out']); $i++) { 
           ?>                               
              <input id="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['id']; ?>" class="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['class']; ?>" type="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['type']; ?>" name="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['name']; ?>" value="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['value']; ?>" <?php if ( $vtprd_rule_display_framework['role_and_or_out'][$i]['value'] == $vtprd_rule->role_and_or_out) { echo $checked; } ?>    /><span id="<?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['id'] . '-label'; ?>"> <?php echo $vtprd_rule_display_framework['role_and_or_out'][$i]['label']; ?></span><br /> 
           <?php } 
           //if neither 'and' nor 'or' selected, select 'or'
         /*  if ( (!$vtprd_rule_display_framework['role_and_or_out'][0]['user_input'] == 's') && (!$vtprd_rule_display_framework['role_and_or_out'][1]['user_input'] == 's') )   {
               $vtprd_rule_display_framework['role_and_or_out'][1]['user_input'] = 's';
           }   */
                      
           ?>                  
          </div>
        
        
        <div id="role-out">
          <h3><?php _e('Role (Membership / Wholesaler)', 'vtprd');?></h3>
          
          <?php
          // ********************************
          $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'roles', 'tax_class' => 'role-out', 'checked_list' => $vtprd_rule->role_out_checked  )));
          // ********************************
          ?>
        </div>
      </div> <?php //end vtprd-pop-out-cntl ?> 
  
  <?php
    }  
      
  
    public    function vtprd_pop_in_specifics( ) {                     
       global $post, $vtprd_info, $vtprd_rule; $vtprd_rules_set;
       $checked = 'checked="checked"';  
  ?>
        
       <div class="column1" id="specDescrip">
          <h4><?php _e('How is the Rule applied to the search results?', 'vtprd');?></h4>
          <p><?php _e("Once we've figured out the population we're working on (cart only or specified groups),
          how do we apply the rule?  Do we look at each product individually and apply the rule to
          each product we find?  Or do we look at the population as a group, and apply the rule to the
          group as a tabulated whole?  Or do we apply the rule to any we find, and limit the application 
          of the rule to a certain number of products?", 'vtprd');?>           
          </p>
       </div>
       <div class="column2" id="specChoiceIn">
          <h3><?php _e('Select Rule Application Method', 'vtprd');?></h3>
          <div id="specRadio">
            <span id="Choice-input-span">
                <?php
               for($i=0; $i < sizeof($vtprd_rule->specChoice_in); $i++) { 
               ?>                 

                  <input id="<?php echo $vtprd_rule->specChoice_in[$i]['id']; ?>" class="<?php echo $vtprd_rule->specChoice_in[$i]['class']; ?>" type="<?php echo $vtprd_rule->specChoice_in[$i]['type']; ?>" name="<?php echo $vtprd_rule->specChoice_in[$i]['name']; ?>" value="<?php echo $vtprd_rule->specChoice_in[$i]['value']; ?>" <?php if ( $vtprd_rule->specChoice_in[$i]['user_input'] > ' ' ) { echo $checked; } ?> /><?php echo $vtprd_rule->specChoice_in[$i]['label']; ?><br />

               <?php
                }
               ?>  
            </span>
            <span class="" id="anyChoiceIn-span">
                <span><?php _e('*Any* applies to a *required*', 'vtprd');?></span><br />
                 <?php _e('Maximum of:', 'vtprd');?>                      
                 <input id="<?php echo $vtprd_rule->anyChoiceIn_max['id']; ?>" class="<?php echo $vtprd_rule->anyChoiceIn_max['class']; ?>" type="<?php echo $vtprd_rule->anyChoiceIn_max['type']; ?>" name="<?php echo $vtprd_rule->anyChoiceIn_max['name']; ?>" value="<?php echo $vtprd_rule->anyChoiceIn_max['value']; ?>">
                 <?php _e('Products', 'vtprd');?>
            </span>           
          </div>                
       </div>                                                
       <div class="column3 specExplanation" id="allChoiceIn-chosen">
          <h4><?php _e('Treat the Selected Group as a Single Entity', 'vtprd');?><span> - <?php _e('explained', 'vtprd');?></span></h4>
          <p><?php _e("Using *All* as your method, you choose to look at all the products from your cart search results.  That means we add
          all the quantities and/or price across all relevant products in the cart, to test against the rule's requirements.", 'vtprd');?>           
          </p>
       </div>
       <div class="column3 specExplanation" id="eachChoiceIn-chosen">
          <h4><?php _e('Each in the Selected Group', 'vtprd');?><span> - <?php _e('explained', 'vtprd');?></span></h4>
          <p><?php _e("Using *Each* as your method, we apply the rule to each product from your cart search results.
          So if any of these products fail to meet the rule's requirements, the cart as a whole receives an error message.", 'vtprd');?>           
          </p>
       </div>
       <div class="column3 specExplanation" id="anyChoiceIn-chosen">
          <h4><?php _e('Apply the rule to any Individual Product in the Cart', 'vtprd');?><span> - <?php _e('explained', 'vtprd');?></span></h4>
          <p><?php _e("Using *Any*, we can apply the rule to any product in the cart from your cart search results, similar to *Each*.  However, there is a
          maximum number of products to which the rule is applied. The product group is checked to see if any of the group fail to reach the maximum amount
          threshhold.  If so, the error will be applied to products in the cart based on cart order, up to the maximum limit supplied.", 'vtprd');?>
          <br /> <br /> 
          <?php _e('For example, the rule might be something like:', 'vtprd');?>
          <br /> <br /> &nbsp;&nbsp;
          <?php _e('"You may buy a maximum of $10 for each of any of 2 products from this group."', 'vtprd');?>              
          </p>               
       </div> 
      
    <?php
  }  
                                                                           
    public    function vtprd_rule_id() {          
        global $post, $vtprd_rule;           
       
        if ($vtprd_rule->ruleInWords > ' ') { ?>
            <span class="ruleInWords" >              
               <span class="clear-left">  <?php echo $vtprd_rule->ruleInWords; ?></span><!-- /clear-left -->                              
            </span><!-- /ruleInWords -->              
        <?php } //end ruleInWords 
  } 
  
    public    function vtprd_rule_resources() {          
        echo '<span id="vtprd-rr-text">' . __('Read documentation, learn the functions and find some tips & tricks.', 'vtprd'). '</span><br>';
        echo '<a id="vtprd-rr-doc"  href="' . VTPRD_DOCUMENTATION_PATH_PRO_BY_PARENT . '"  title="Access Plugin Documentation">' . __('Plugin Documentation', 'vtprd'). '</a>';
        echo '<span id="vtprd-rr-text"><br><strong>' . __('Tip:', 'vtprd') .'</strong>'. __(' *Product*', 'vtprd') 
            .'<br>&nbsp;&nbsp;&nbsp;<em>'.
            __('inclusion or exclusion', 'vtprd')
            .'</em><br>&nbsp;&nbsp;&nbsp;' . __('for ', 'vtprd') .'<em>'. __('all rules', 'vtprd')
            .'</em><br>&nbsp;&nbsp;&nbsp;'.
            __('on Product page', 'vtprd')
            . '</span><br><br>';
        echo '<span id="vtprd-rr-box">';
        echo '<span id="vtprd-rr-created">by VarkTech.com</span>';
        echo '<a id="vtprd-rr-vote"  href="' . VTPRD_DOWNLOAD_FREE_VERSION_BY_PARENT . '"  title="' . __('Vote for the Plugin', 'vtprd'). '">Vote</a>';
        echo '</span>'; //end rr-box
        
        //Back to the Top box, fixed at lower right corner!!!!!!!!!!
        echo '<a href="#" id="back-to-top-tab" class="show-tab">' . __('Back to Top', 'vtprd'). ' <strong>&uarr;</strong></a>';
  }   

      
    public    function vtprd_rule_scheduling() {             //periodicByDateRange
        global $vtprd_rule;
        
        //**********************************************************************************
        //script goes here, rather than in enqueued resources, due to timing issues 
        //**********************************************************************************
       ?>     
          <script type="text/javascript">
          jQuery.noConflict();
          jQuery(document).ready(function($) {
             //DatePicker                       
             // from  http://jquerybyexample.blogspot.com/2012/01/end-date-should-not-be-greater-than.html
                $("#date-begin-0").datepicker({
                  dateFormat : 'yy-mm-dd', 
                  minDate: 0,
                 // maxDate: "+60D",
                  numberOfMonths: 2,
                  onSelect: function(selected) {
                    $("#date-end-0").datepicker("option","minDate", selected)
                  }
              });
              $("#date-end-0").datepicker({ 
                  dateFormat : 'yy-mm-dd', 
                  minDate: 0,
                 // maxDate:"+60D",
                  numberOfMonths: 2,
                  onSelect: function(selected) {
                     $("#date-begin-0").datepicker("option","maxDate", selected)
                  }                             
              });

            });   
          </script>                            
     <?php       
     //load up default if no date range
     if ( sizeof($vtprd_rule->periodicByDateRange) == 0 ) {     
        $vtprd_rule->periodicByDateRange[0]['rangeBeginDate'] = date('Y-m-d');
        $vtprd_rule->periodicByDateRange[0]['rangeEndDate']   = (date('Y')+1) . date('-m-d') ;
     } 
     ?> 
        <span class="basic-begin-date-area">          
          <span class="begin-date first-in-line-label" id='begin-date-label-0' >Begin Date: 
          </span>                    
          <input type='text' id='date-begin-0' class='pickdate' size='7' value="<?php echo $vtprd_rule->periodicByDateRange[0]['rangeBeginDate']; ?>" name='date-begin-0' />				
        </span>        
        <span class="basic-end-date-area">          
          <span class="end-date first-in-line-label" id='end-date-label-0'>End Date: 
          </span>                     
          <input type='text' id='date-end-0'   class='pickdate' size='7' value="<?php echo $vtprd_rule->periodicByDateRange[0]['rangeEndDate']; ?>"   name='date-end-0'   />          
        </span>        
        
    <?php      
       global $vtprd_setup_options;
       if ( $vtprd_setup_options['use_this_timeZone'] == 'none') {
          echo __('<span id="options-setup-error" style="color:red !important;">Scheduling requires setup: <a  href="/wp-admin/edit.php?post_type=vtprd-rule&page=vtprd_setup_options_page"  title="select">Please - Click Here - to Select the Store GMT Time Zone</a></span>', 'vtprd'); 
        }          

  }   

  public  function vtprd_change_title_currency_symbol( $variable_name, $i, $currency_symbol ) {
     global $vtprd_deal_screen_framework;
      //replace $$ with setup currency!!                        
      $vtprd_deal_screen_framework[$variable_name]['option'][$i]['title'] = 
                str_replace('$$', $currency_symbol, $vtprd_deal_screen_framework[$variable_name]['option'][$i]['title'] );
  }    
       
  public  function vtprd_post_category_meta_box( $post, $box ) {
      $defaults = array('taxonomy' => 'category');
      if ( !isset($box['args']) || !is_array($box['args']) )
          $args = array();
      else
          $args = $box['args'];
      extract( wp_parse_args($args, $defaults), EXTR_SKIP );
      $tax = get_taxonomy($taxonomy);

      ?>
      <div id="taxonomy-<?php echo $taxonomy; ?>" class="categorydiv">
   
          <div id="<?php echo $taxonomy; ?>-pop" class="tabs-panel" style="display: none;">
              <ul id="<?php echo $taxonomy; ?>checklist-pop" class="categorychecklist form-no-clear" >
                  <?php $popular_ids = wp_popular_terms_checklist($taxonomy); ?>
              </ul>
          </div>
   
          <div id="<?php echo $taxonomy; ?>-all" class="tabs-panel">
              <?php
              $name = ( $taxonomy == 'category' ) ? 'post_category' : 'tax_input[' .  $tax_class . ']';     //vark replaced $taxonomy with $tax_class
              echo "<input type='hidden' name='{$name}[]' value='0' />"; // Allows for an empty term set to be sent. 0 is an invalid Term ID and will be ignored by empty() checks.
              ?>
              <ul id="<?php echo $taxonomy; ?>checklist" class="list:<?php echo $taxonomy?> categorychecklist form-no-clear">
      <?php    

            switch( $taxonomy ) {
              case 'roles': 
                  $vtprd_checkbox_classes = new VTPRD_Checkbox_classes; 
                  $vtprd_checkbox_classes->vtprd_fill_roles_checklist($tax_class, $checked_list);
                break;
              case 'variations':                  
                  vtprd_fill_variations_checklist($tax_class, $checked_list, $pop_in_out_sw, $product_ID, $product_variation_IDs);                            
                break;
              default:  //product category or vtprd category...
                  $this->vtprd_build_checkbox_contents ($taxonomy, $tax_class, $checked_list, $pop_in_out_sw);                             
                break;
            }
            
      ?>  
              </ul>
          </div>
      <?php if ( current_user_can($tax->cap->edit_terms) && !($taxonomy == 'roles') && !($taxonomy == 'variations') ): ?>
              <div id="<?php echo $taxonomy; ?>-adder" class="wp-hidden-children">
                  <h4>
                      <a id="<?php echo $taxonomy; ?>-add-toggle" href="#<?php echo $taxonomy; ?>-add" class="hide-if-no-js" tabindex="3">
                          <?php
                              /* translators: %s: add new taxonomy label */
                              printf( __( '+ %s' ), $tax->labels->add_new_item );
                          ?>
                      </a>
                  </h4>
                  <p id="<?php echo $taxonomy; ?>-add" class="category-add wp-hidden-child">
                      <label class="screen-reader-text" for="new<?php echo $taxonomy; ?>"><?php echo $tax->labels->add_new_item; ?></label>
                      <input type="text" name="new<?php echo $taxonomy; ?>" id="new<?php echo $taxonomy; ?>" class="form-required form-input-tip" value="<?php echo esc_attr( $tax->labels->new_item_name ); ?>" tabindex="3" aria-required="true"/>
                      <label class="screen-reader-text" for="new<?php echo $taxonomy; ?>_parent">
                          <?php echo $tax->labels->parent_item_colon; ?>
                      </label>
                      <?php wp_dropdown_categories( array( 'taxonomy' => $taxonomy, 'hide_empty' => 0, 'name' => 'new'.$taxonomy.'_parent', 'orderby' => 'name', 'hierarchical' => 1, 'show_option_none' => '&mdash; ' . $tax->labels->parent_item . ' &mdash;', 'tab_index' => 3 ) ); ?>
                      <input type="button" id="<?php echo $taxonomy; ?>-add-submit" class="add:<?php echo $taxonomy ?>checklist:<?php echo $taxonomy ?>-add button category-add-sumbit" value="<?php echo esc_attr( $tax->labels->add_new_item ); ?>" tabindex="3" />
                      <?php wp_nonce_field( 'add-'.$taxonomy, '_ajax_nonce-add-'.$taxonomy, false ); ?>
                      <span id="<?php echo $taxonomy; ?>-ajax-response"></span>
                  </p>
              </div>
          <?php endif; ?>
      </div>
      <?php
}


    function vtprd_load_forThePriceOf_literal($k) {
      global $vtprd_rule;
     if (($vtprd_rule->rule_deal_info[$k]['discount_amt_type'] =='forThePriceOf_Units') ||
         ($vtprd_rule->rule_deal_info[$k]['discount_amt_type'] =='forThePriceOf_Currency')) {
        switch ($vtprd_rule->rule_template) {
          case 'C-forThePriceOf-inCart':    //buy-x-action-forThePriceOf-same-group-discount              
              echo ' Buy ';
              echo $vtprd_rule->rule_deal_info[$k]['buy_amt_count'];
            break;
          case 'C-forThePriceOf-Next':  //buy-x-action-forThePriceOf-other-group-discount
              echo ' Get ';
              echo $vtprd_rule->rule_deal_info[$k]['action_amt_count'];
            break;
        }
      }
    }


    //remove conflict with all-in-one seo pack!!  
    //  from http://wordpress.stackexchange.com/questions/55088/disable-all-in-one-seo-pack-for-some-custom-post-types
    function vtprd_remove_all_in_one_seo_aiosp() {
        $cpts = array( 'vtprd-rule' );
        foreach( $cpts as $cpt ) {
            remove_meta_box( 'aiosp', $cpt, 'advanced' );
        }
    }


    
  /*
    *  taxonomy (r) - registered name of taxonomy
    *  tax_class (r) - name options => 'prodcat-in' 'prodcat-out' 'rulecat-in' 'rulecat-out'
    *             refers to product taxonomy on the candidate or action categories,
    *                       rulecat taxonomy on the candidate or action categories
    *                         :: as there are only these 4, they are unique   
    *  checked_list (o) - selection list from previous iteration of rule selection                              
    *                          
   */

  public function vtprd_build_checkbox_contents ($taxonomy, $tax_class, $checked_list = NULL, $pop_in_out_sw ) {
        global $wpdb, $vtprd_info;         
        $sql = "SELECT terms.`term_id`, terms.`name`  FROM `" . $wpdb->prefix . "terms` as terms, `" . $wpdb->prefix . "term_taxonomy` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`taxonomy` = '" . $taxonomy . "' ORDER BY terms.`term_id` ASC";                         
		    $categories = $wpdb->get_results($sql,ARRAY_A) ;
        
        foreach ($categories as $category) {
            
            $term_id = $category['term_id'];
            
            $output  = '<li id='.$taxonomy.'-'.$term_id.'>' ;
            $output  .= '<label class="selectit  '.$taxonomy.'-list-checkbox">' ;
            $output  .= '<input id="'.$tax_class.'.'.$taxonomy.'-'.$term_id.' " ';
            $output  .= 'type="checkbox" name="tax-input-' .  $tax_class . '[]" ';
            $output  .= 'value="'.$term_id.'" ';
            $check_found = 'no';
            if ($checked_list) {
                if (in_array($term_id, $checked_list)) {   //if cat_id is in previously checked_list      if (in_array("Irix", $os)) {
                   $output  .= 'checked="checked"';
                   $check_found = 'yes';
                }               
            }
           /*
            if ( ($taxonomy == $vtprd_info['parent_plugin_taxonomy']) || ($taxonomy == $vtprd_info['rulecat_taxonomy']) )           {       
                  $output  .= ' disabled="disabled"';
            }
            */
            $output  .= '>'; //end input statement
            $output  .= '&nbsp;' . $category['name'];
            $output  .= '</label>';            
            $output  .= '</li>';
              echo $output ;    
         }
         return;
    }



    /*
     *  ==========================
     *     AJAX Functions
     *  ==========================                                
     */

    public function vtprd_ajax_load_variations_in() {
    global $wpdb, $post, $vtprd_rule;
       /*  *********************************************
         USE exit rather than return
         as the return statement engerders a 0 return code in the ajax
         which displays as an errant '0' with the ajax display. 
        ********************************************* */
    $vtprd_rule->inPop_varProdID['value']  = $_POST['inVarProdID'];  //from var *passed in from ajax js     
    $product_ID = $vtprd_rule->inPop_varProdID['value'];
    $product_variation_IDs = $this->vtprd_ajax_edit_product($product_ID, 'in');
    
    if ($vtprd_rule->rule_error_message[0] > ' ') {
       echo '<div id="inVariationsError">';
       echo $vtprd_rule->rule_error_message[0];
       echo '</div>';
    } else {
       $this->vtprd_ajax_show_variations_in ($product_variation_IDs); 
    }
          
    exit;
  }   //end ajax_load_variations_in(

    public function vtprd_ajax_load_variations_out() {
    global $wpdb, $post, $vtprd_rule;
       /*  *********************************************
         USE exit rather than return
         as the return statement engerders a 0 return code in the ajax
         which displays as an errant '0' with the ajax display. 
        ********************************************* */
    $vtprd_rule->actionPop_varProdID['value']  = $_POST['outVarProdID'];  //from var *passed in from ajax js     
    $product_ID = $vtprd_rule->actionPop_varProdID['value'];
    $product_variation_IDs = $this->vtprd_ajax_edit_product($product_ID, 'out');
    
    if ($vtprd_rule->rule_error_message[0] > ' ') {
       echo '<div id="outVariationsError">';
       echo $vtprd_rule->rule_error_message[0];
       echo '</div>';
    } else {
       $this->vtprd_ajax_show_variations_out ($product_variation_IDs);
    }
          
    exit;
  }   //end ajax_load_variations_out(
     
  public function vtprd_ajax_edit_product($product_ID, $inOrOut) {
    global $wpdb, $post, $vtprd_rule, $vtprd_setup_options;
    
    //edits copied from vtprd-rules-update.php
    if ($product_ID == ' '){
      $vtprd_rule->rule_error_message[] = __('No Product ID was supplied.', 'vtprd');
      return;
    } 
     
    if ( is_numeric($product_ID) === false ) {
       $vtprd_rule->rule_error_message[0] =  __('<br><br>Product ID in error = <span id="varProdID-error-ID">', 'vtprd')   .$product_ID .    __('</span>', 'vtprd') ;
               
       if ( $vtprd_setup_options['debugging_mode_on'] == 'yes' ){
          $vtprd_rule->rule_error_message[0] =  __('<br><br>Product ID in error = <span id="varProdID-error-ID">', 'vtprd')   .$product_ID .    __('</span>', 'vtprd') ;
       }              
       return;
    } 
    
    $test_post = get_post($product_ID);
    if (!$test_post ) {
       $vtprd_rule->rule_error_message[] =  __('Product ID was not found. >', 'vtprd') ;                    
      if ( $vtprd_setup_options['debugging_mode_on'] == 'yes' ){
          $vtprd_rule->rule_error_message[0] =  __('<br><br>Product ID in error = <span id="varProdID-error-ID">', 'vtprd')   .$product_ID .    __('</span>', 'vtprd') ; 
       }  
      return;
    }
    
    if ($inOrOut == 'in') {
      $vtprd_rule->inPop_varProdID_name      = $test_post->post_title;
    } else {
      $vtprd_rule->actionPop_varProdID_name  = $test_post->post_title;
    }
    
    
    $product_has_variations = vtprd_test_for_variations($product_ID);

    if ($product_has_variations == 'no') {
      $vtprd_rule->rule_error_message[] =  __('Product has no Variations. Product Name = ', 'vtprd') .$test_post->post_title.   __('<br><br> Please use "Single Product Only" option, above.', 'vtprd') ;
      if ( $vtprd_setup_options['debugging_mode_on'] == 'yes' ){
          $vtprd_rule->rule_error_message[0] =  __('<br><br>Product ID in error = <span id="varProdID-error-ID">', 'vtprd')   .$product_ID .    __('</span>', 'vtprd') ;
       }  
      return;
    }
    
    $product_variation_IDs = vtprd_get_variations_list($product_ID);
    if ($product_variation_IDs <= ' ') { 
      $vtprd_rule->rule_error_message[] = __('Product has no Variations. Product Name = ', 'vtprd') .$test_post->post_title.   __('<br><br> Please use "Single Product Only" option, above.', 'vtprd') ;
      if ( $vtprd_setup_options['debugging_mode_on'] == 'yes' ){
          $vtprd_rule->rule_error_message[0] =  __('<br><br>Product ID in error = <span id="varProdID-error-ID">', 'vtprd')   .$product_ID .    __('</span>', 'vtprd') ;
       }  
      return;
    }
    
    return ($product_variation_IDs);
  } 
  
     
  public function vtprd_ajax_show_variations_in ($product_variation_IDs) {
     global $post, $vtprd_info, $vtprd_rule; $vtprd_rules_set;
     ?>             
          <h3><?php _e('Product Variations', 'vtprd');?></h3>                  
     <?php
            //********************************
            $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'variations', 'tax_class' => 'var-in', 'checked_list' => $vtprd_rule->var_in_checked, 'product_ID' => $vtprd_rule->inPop_varProdID['value'], 'product_variation_IDs' => $product_variation_IDs )));
            // ******************************** 
            //output hidden count of all variation checkboxes.  Used on update to store info used in 'yousave' messaging
            ?>
            <input type="hidden" id="checkbox_count-var-in" name="checkbox_count-var-in" value="<?php echo $vtprd_info['inpop_variation_checkbox_total']; ?>" />
            <?php                 
  } 
  
  public function vtprd_ajax_show_variations_out ($product_variation_IDs) {
     global $post, $vtprd_info, $vtprd_rule; $vtprd_rules_set;
     ?>             
          <h3><?php _e('Product Variations', 'vtprd');?></h3>                  
     <?php
            //********************************
            $this->vtprd_post_category_meta_box($post, array( 'args' => array( 'taxonomy' => 'variations', 'tax_class' => 'var-out', 'checked_list' => $vtprd_rule->var_out_checked, 'product_ID' => $vtprd_rule->actionPop_varProdID['value'], 'product_variation_IDs' => $product_variation_IDs )));
            // ********************************                 
  } 

  //     END AJAX Functions


  // *********************************************************
  //   META BOX for PARENT PLUGIN PRODUCT SCREEN
  // *********************************************************          
  public  function vtprd_parent_product_meta_box_cntl() {
      global $post, $vtprd_info, $vtprd_rule, $vtprd_rules_set;        
      
      if(defined('VTPRD_PRO_DIRNAME')) {
        $metabox_title =  __('Pricing Deals: Product Include or Exclude', 'vtprd');
      } else {
        $metabox_title =  __('Pricing Deals: Product Include or Exclude', 'vtprd') . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . __('(Available with the Pro plugin)', 'vtprd') ;
      }
      
      add_meta_box('vtprd-pricing-deal-info', $metabox_title , array(&$this, 'vtprd_add_parent_product_meta_box'), $vtprd_info ['parent_plugin_cpt'], 'normal', 'low');                           
  }                   
  /*
  // *********************************************************
     add a meta box to the PARENT PLUGIN'S PRODUCT SCREEN
       * Rule include/exclude info at the product level
       * anchor redirect in the category matabox, to this box, 
       *        inserts directly onto the page 
         from vtprd-admin-product-metabox-script.js
  // ********************************************************* 
  */      
  public  function vtprd_add_parent_product_meta_box() {
      global $post, $vtprd_info, $vtprd_rule, $vtprd_rules_set, $vtprd_rule_display_framework ;        
      $selected = 'selected="selected"';
      
      if ( get_post_meta($post->ID, $vtprd_info['product_meta_key_includeOrExclude'], true) ) {
        $vtprd_includeOrExclude = get_post_meta($post->ID, $vtprd_info['product_meta_key_includeOrExclude'], true);
      } else {
        $vtprd_includeOrExclude = array (
            'includeOrExclude_option'    => 'includeAll', //initialize the value...
            'includeOrExclude_checked_list'    => array() 
          );
      }
      
      ?>    
        <?php //pass literals up to JS, translated here if necessary ?>
        <input type="hidden" id="vtprd-sectionTitle" name="vtprd-sectionTitle" value="<?php _e('Pricing Deals Include or Exclude', 'vtprd');?>" >
        <input type="hidden" id="vtprd-urlTitle" name="vtprd-urlTitle" value="<?php _e('Product Include or Exclude', 'vtprd');?>" >      
        <input id="vtprd-pluginVersion" type="hidden" value="<?php if(defined('VTPRD_PRO_DIRNAME')) { echo "proVersion"; } else { echo "freeVersion"; } ?>" name="vtprd-pluginVersion">       
        
        <h4 id="includeOrExclude-area-title"><?php _e('*Include or Exclude Product*', 'vtprd'); echo '&nbsp;'; _e(' in Pricing Deals Rule processing, based on the Options and Rule List below', 'vtprd');?></h4>                    
        <div class="dropdown includeOrExclude_area clear-left" id="includeOrExclude_areaID">              
           <span class="dropdown-label" id="includeOrExclude_label"><?php _e('Product Options:', 'vtprd');?></span>               
           <select id="<?php echo $vtprd_rule_display_framework['includeOrExclude']['select']['id'];?>" class="<?php echo$vtprd_rule_display_framework['includeOrExclude']['select']['class']; ?>" name="<?php echo $vtprd_rule_display_framework['includeOrExclude']['select']['name'];?>" tabindex="<?php echo $vtprd_rule_display_framework['includeOrExclude']['select']['tabindex']; ?>" >          
             <?php
             for($i=0; $i < sizeof($vtprd_rule_display_framework['includeOrExclude']['option']); $i++) {            
             ?>                             
                <option id="<?php echo $vtprd_rule_display_framework['includeOrExclude']['option'][$i]['id']; ?>"  class="<?php echo $vtprd_rule_display_framework['includeOrExclude']['option'][$i]['class']; ?>"  value="<?php echo $vtprd_rule_display_framework['includeOrExclude']['option'][$i]['value']; ?>" <?php if ($vtprd_rule_display_framework['includeOrExclude']['option'][$i]['value'] == $vtprd_includeOrExclude['includeOrExclude_option'] )  { echo $selected; } ?> >  <?php echo $vtprd_rule_display_framework['includeOrExclude']['option'][$i]['title']; ?> </option>
             <?php } ?> 
           </select> 
           <?php vtprd_show_help_tooltip($context = 'includeOrExclude', $location = 'title'); ?>
        </div>
 
          <div id="includeOrExclude-all" class="tabs-panel">
            <h3 id="includeOrExclude-title">Pricing Deal Rule List</h3>
            <p id="includeOrExclude-area-title2"><?php _e("These selections do not ", 'vtprd'); echo '<em>'; _e("force", 'vtprd'); echo '</em>'; 
                _e(" the product's participation in a rule.  ", 'vtprd'); echo '<em>'; _e("Inclusion only applies if the product naturally falls
                into the specified rule populations already.", 'vtprd'); echo '</em>'; ?></p>
            <ul id="includeOrExclude-checklist" class="categorychecklist form-no-clear">   
                  <?php  vtprd_fill_include_exclude_lists ($vtprd_includeOrExclude['includeOrExclude_checked_list'])?>  
            </ul>
          </div>      
      
      
      <?php 
       
      return;
  }    
 
         
  public  function vtprd_build_new_rule() {
      global $post, $vtprd_info, $vtprd_rule, $vtprd_rules_set, $vtprd_deal_structure_framework; 
                    
        //initialize rule
        $vtprd_rule = new VTPRD_Rule;
 
         //fill in standard default values not already supplied
         
        //load the 1st iteration of deal info by default    => internal defaults set in vtprd_deal_structure_framework
        
        $vtprd_rule->rule_deal_info[] = $vtprd_deal_structure_framework;  

        $vtprd_rule->rule_deal_info[0]['buy_repeat_condition'] = 'none'; 
        $vtprd_rule->rule_deal_info[0]['buy_amt_type'] = 'none';
        $vtprd_rule->rule_deal_info[0]['buy_amt_mod'] = 'none';
        $vtprd_rule->rule_deal_info[0]['buy_amt_applies_to'] = 'all';
        $vtprd_rule->rule_deal_info[0]['action_repeat_condition'] = 'none'; 
        $vtprd_rule->rule_deal_info[0]['action_amt_type'] = 'none';  
        $vtprd_rule->rule_deal_info[0]['action_amt_mod'] = 'none';
        $vtprd_rule->rule_deal_info[0]['action_amt_applies_to'] = 'all';
        $vtprd_rule->rule_deal_info[0]['discount_amt_type'] = '0';
        $vtprd_rule->rule_deal_info[0]['discount_applies_to'] = 'each';
        $vtprd_rule->rule_deal_info[0]['discount_rule_max_amt_type'] = 'none';
        $vtprd_rule->rule_deal_info[0]['discount_lifetime_max_amt_type'] = 'none';
        $vtprd_rule->rule_deal_info[0]['discount_rule_cum_max_amt_type'] = 'none'; 
        $vtprd_rule->cumulativeRulePricing = 'no';  
        $vtprd_rule->cumulativeSalePricing = 'no';  
        $vtprd_rule->cumulativeCouponPricing = 'no';
               //discount occurs 5 times
        $vtprd_rule->ruleApplicationPriority_num = '10';         
        $vtprd_rule->rule_type_selected_framework_key =  'Title01'; //default 1st title for BOTH dropdowns
        
        $vtprd_rule->inPop = 'wholeStore';  //apply to all products
        $vtprd_rule->role_and_or_in = 'or';
        $vtprd_rule->actionPop = 'sameAsInPop' ; 
        $vtprd_rule->role_and_or_out = 'or';
        
        //new upper selects 
        $vtprd_rule->cart_or_catalog_select = 'choose';
        $vtprd_rule->pricing_type_select = 'choose';
        $vtprd_rule->minimum_purchase_select = 'none';
        $vtprd_rule->buy_group_filter_select = 'choose';
        $vtprd_rule->get_group_filter_select = 'choose';
        $vtprd_rule->on_off_switch = 'on';          
         
    return;
  }        
     //lots of selects change their values between standard and 'discounted' titles.
    //This is where we supply the HIDEME alternative titles
  public  function vtprd_print_alternative_title_selects() {
      global $vtprd_rule_display_framework, $vtprd_deal_screen_framework;
      ?>          
             
           <?php 
           /* +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
             Hidden Selects containing various versions of the Select Option texts.
             
                #1  = the default version of the titles
                #2  = the altenate (Discount) version of the titles
              
              Both are supplied, so the JS can toggle between these two sets,
              as needed by the Upper select choices
              +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
           */ ?>  
             <?php //Upper  pricint_type_select?>  
              <select id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['id'] .'1';?>" class="<?php echo$vtprd_rule_display_framework['pricing_type_select']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['pricing_type_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['title'];
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['id'] .'-catalog';?>" class="<?php echo$vtprd_rule_display_framework['pricing_type_select']['select']['class'] .'-catalog'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['name'] .'-catalog';?>" tabindex="<?php echo $vtprd_rule_display_framework['pricing_type_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['pricing_type_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title 
                      $title = $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['title-catalog'];
                
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['id'] .'-catalog'; ?>"  class="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['class'] .'-catalog'; ?>"  value="<?php echo $vtprd_rule_display_framework['pricing_type_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>   
                          
             
             <?php //Upper  minimum_purchase_select?>  
              <select id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['id'] .'1';?>" class="<?php echo$vtprd_rule_display_framework['minimum_purchase_select']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['minimum_purchase_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['title'];
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['id'] .'-catalog';?>" class="<?php echo$vtprd_rule_display_framework['minimum_purchase_select']['select']['class'] .'-catalog'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['name'] .'-catalog';?>" tabindex="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['minimum_purchase_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title 
                      $title = $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['title-catalog'];
                
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['id'] .'-catalog'; ?>"  class="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['class'] .'-catalog'; ?>"  value="<?php echo $vtprd_rule_display_framework['minimum_purchase_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>   
             
             <?php //Upper  buy_group_filter_select?>  
              <select id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['id'] .'1';?>" class="<?php echo$vtprd_rule_display_framework['buy_group_filter_select']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['buy_group_filter_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title => in this case, title and title3
                      $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title3'];                        
                      }
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['id'] .'2';?>" class="<?php echo$vtprd_rule_display_framework['buy_group_filter_select']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['buy_group_filter_select']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title 
                      $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title2'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title4'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['title4'];                        
                      }                
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_rule_display_framework['buy_group_filter_select']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>  
      
             <?php //buy_amt_type ?>  
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['id'] .'1';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_type']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_type']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['id'] .'2';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_type']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_type']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_type']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select>  
               
             <?php //buy_amt_applies_to ?>  
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['id'] .'1';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_applies_to']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_applies_to']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['id'] .'2';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_applies_to']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_applies_to']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_applies_to']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select>  
               
             <?php //buy_amt_mod ?>  
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['id'] .'1';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_mod']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_mod']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['id'] .'2';?>" class="<?php echo$vtprd_deal_screen_framework['buy_amt_mod']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_amt_mod']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_amt_mod']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select>  
             
            <?php //buy_repeat_condition ?>  
              <select id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['id'] .'1';?>" class="<?php echo$vtprd_deal_screen_framework['buy_repeat_condition']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_repeat_condition']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['id'] .'2';?>" class="<?php echo$vtprd_deal_screen_framework['buy_repeat_condition']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['buy_repeat_condition']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['buy_repeat_condition']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select>  
      
             <?php //action_amt_type ?>  
              <select id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['id'] .'1';?>" class="<?php echo$vtprd_deal_screen_framework['action_amt_type']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_amt_type']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['id'] .'2';?>" class="<?php echo$vtprd_deal_screen_framework['action_amt_type']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_deal_screen_framework['action_amt_type']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_deal_screen_framework['action_amt_type']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['value']; ?>"    ><?php echo $vtprd_deal_screen_framework['action_amt_type']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select> 
               
            <?php //inPop ?>  
              <select id="<?php echo $vtprd_rule_display_framework['inPop']['select']['id'] .'1';?>" class="<?php echo$vtprd_rule_display_framework['inPop']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['inPop']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_rule_display_framework['inPop']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['inPop']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title 
                      $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['inPop']['option'][$i]['title3'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title3'];                        
                      }                  
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_rule_display_framework['inPop']['select']['id'] .'2';?>" class="<?php echo$vtprd_rule_display_framework['inPop']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['inPop']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_rule_display_framework['inPop']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['inPop']['option']); $i++) { 
                                             
                      //pick up the free/pro version of the title 
                      $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title2'];
                      if ( ( defined('VTPRD_PRO_DIRNAME') ) &&
                           ( $vtprd_rule_display_framework['inPop']['option'][$i]['title4'] > ' ' ) ) {
                        $title = $vtprd_rule_display_framework['inPop']['option'][$i]['title4'];                        
                      }                    
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_rule_display_framework['inPop']['option'][$i]['value']; ?>"    ><?php echo $title; ?></option>
                 <?php } ?> 
               </select>  
                 
             <?php //specChoice_in ?>  
              <select id="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['id'] .'1';?>" class="<?php echo$vtprd_rule_display_framework['specChoice_in']['select']['class'] .'1'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['name'] .'1';?>" tabindex="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['tabindex']; ?>" >          
                 <?php
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['specChoice_in']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['id'] .'1'; ?>"  class="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['class'] .'1'; ?>"  value="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['value']; ?>"    ><?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['title']; ?></option>
                 <?php } ?> 
               </select>                                        
              <select id="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['id'] .'2';?>" class="<?php echo$vtprd_rule_display_framework['specChoice_in']['select']['class'] .'2'; ?> hideMe" name="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['name'] .'2';?>" tabindex="<?php echo $vtprd_rule_display_framework['specChoice_in']['select']['tabindex']; ?>" >          
                 <?php                                               
                 for($i=0; $i < sizeof($vtprd_rule_display_framework['specChoice_in']['option']); $i++) { 
                 ?>                             
                    <option id="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['id'] .'2'; ?>"  class="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['class'] .'2'; ?>"  value="<?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['value']; ?>"    ><?php echo $vtprd_rule_display_framework['specChoice_in']['option'][$i]['title2']; ?></option>
                 <?php } ?> 
               </select>  
                          
   <?php         
  }          
      
} //end class